; 07 08 1991 - Extinction d'cran & manipulation mmoire vido

; Les paramtres entre [ ] sont facultatifs.
; SSAVE([ ecrx, ] xpos,ypos,xsiz,ysiz) sauve tout/partie d'1 des 2 crans
; SSHOW adr...................... restaure  volont zone sauve
; SMOVE ecrx,adr,[ xpos,ypos ]... dplace l'image de la zone sauve
; SLOAD adr...................... restaure zone sauve et cloture action
; SSTAT ......................... indique l'cran actif (0 ou 1)
; SCRON ......................... claire sur ordre les crans du QL
; SCROF ......................... teint sur ordre les crans du QL

; ecrx = 0 ou 1 - Ecr 0 ou Ecr 1 (son existence est teste)
; adr  = val retourne par SSAVE et utilise par SLOAD, SSHOW & SMOVE
; temp = fixe tempo en secondes - val <= 0 ou absent dsaction la routine
; xpos = colone relative  la colone gauche de l'cran (0)
; ypos = ligne relative  la ligne suprieure de l'cran (0)
; xsiz = nb de colones dsires
; ysiz = nb de lignes dsires
; Les valeurs de ces 2 derniers paramtres rajustent automatiquement
; xpos & ypos pour que la restauration n'affecte pas les variables
; systme du QDos. Il en rsulte qu'une mauvaise apprciation de la
; nouvelle position de restauration (SMOVE) peut ne pas donner le
; rsultat escompter. Cette contrainte vite de mchants plantages...

;                                          J.Tripodi
;                               Le QListe allum des terres froides

; Tous ces mots cls SuperBasic sont compatibles avec MINERVA et devraient
; l'tre avec les THOR et ATARI muls. Si pb appelez au 74 56 17 90 ou
; mieux crivez  Mr Tripodi Jacques - (Le Vernay) - 38790 Charantonnay

               in flp2_QLTRAP12_lib               ;Liste traps 1 & 2
; nu               in flp2_QLTRAP34_lib               ;Liste traps 3
               in flp2_QLVECTOR_lib               ;Liste vecteurs
               in flp2_QLVARBAS_lib               ;Liste variables basic
               in flp2_QLSYSVAR_lib               ;Liste variables systme
; nu               in flp2_QLWINDEF_lib               ;Mnmoniques pour window
; nu               in flp2_QLCANDEF_lib               ;Mnmoniques pour E/S
; nu               in flp2_QLHEADEF_lib               ;Mnmoniques pour en-tte

MC.STAT        equ       $018063                  ;Registre statut IPC

; Source procdure ECRAN MANAGER v0.12 - 1991

               lea.l     DEF_PRFN,a1
               move.w    BP.INIT,a2
               jmp       (a2)

; Code des procdures & fonctions

SCROF          bsr.s     TST_RSTA
               st        MC.STAT                  ;Eteint spot
               rts

SCRON          bsr.s     TST_VS
               bsr.s     TST_RSTA
               move.b    d1,MC.STAT               ;Allume spot avec val de
               rts                                ;SV.MCSTA et retour

TST_VS         moveq     #MT.INF,d0               ;O sont Var systme ?
               trap      #$01                     ;a0 = base var systme
               move.b    SV.MCSTA(a0),d1          ;d1=statut actuel cran

TST_RSTA       tst.b     MC.STAT                  ;Balayage cran achev ?
               bpl.s     TST_RSTA                 ;Non ! recommence...
               rts                                ;Oui ! Retour

; Cette fonction n'est utile qu'en cas de second cran de MINERVA, elle
; permet de savoir quel cran est dit "affich" par la commande mode 80,-1
; car CTRL TAB switche les 2 crans sans le dire  SV.MCSTA  qui ne reste
; dans l'tat o l'a mise le dernier ordre MODE x,n. Cette fonction permet
; de tester si l'cran visible est bien l'cran activ par le programme
; (basic ou compil) et envoyer si ncessaire un ordre de changement.

SSTAT          moveq     #MT.INF,d0               ;Hou ! Hou ! var sys ?
               trap      #$01
               move.b    SV.MCSTA(a0),d1          ;prlve val SV.MCSTA
               lsr.b     #$07,d1                  ;Vire les bits inutiles
               move.l    BV.RIP(a6),a1            ;Rserve place pour
               subq      #$02,a1                  ;1 entier
               move.l    a1,BV.RIP(a6)            ;Actualise pile arith
               move.w    d1,(a6,a1.l)             ;Envoie n ecran (0/1)
               moveq     #$03,d4                  ;Fixe le type entier
               bra       EXIT.OK                  ;Retour SB

; Les rtn ci-dessous permettent de manipuler la mmoire vido leur action
; est rapide et on peut agir sur les deux crans de MINERVA. Ces routines
; testent elles-mme la prsence ventuelle du second cran. Il est mme
; possible de dplacer une zone dans l'cran et mme de la transfrer dans
; un cran diffrent (SMOVE). Ceci n'affecte pas la restauration automati-
; que, cloturante ou non (SLOAD & SSHOW).

INFO_VS        moveq     #MT.INF,d0               ;Cherche infos systme
               trap      #$01
               movea.l   a0,a4                    ;Prserve adr var sys
               cmpa.l    #$30000,a0               ;Ecran 1 existe ?
               bne.s     ECR_0                    ;Non ? alors no problem
               move.l    #$01,d7                  ;Oui ? d7= flag ECR1

ECR_0          move.w    CA.GTLIN,a2              ;Recherche nb param.
               jsr       (a2)
               rts

SSHOW          move.l    #$00,d7                  ;d7=switch sshow/sload
               bra.s     SC_LOAD                  ;d7=0 : sshow utilis

SLOAD          move.l    #$01,d7                  ;d7=1 : sload utilis

SC_LOAD        bsr.s     ECR_0                    ;Cherche nb paramtres
               bne       EXIT                     ;Ret SB si pas trouvs
               subq.w    #$01,d3                  ;Vrifie un seul param
               bne       ERR.BP                   ;Sinon ret SB...
               movea.l   $00(a6,a1.l),a0          ;a0= adr bloc mmoire
               move.l    (a0),-(a7)               ;Place adr(a0)/ SP
               move.l    a0,-(a7)                 ;Place val a0/ SP

SC_MOVE        clr.l     d3                       ;Nettoie d3 & d4
               clr.l     d4
               movea.l   (a0)+,a2                 ;a2= adr image / cran
               move.b    (a0)+,d3                 ;d3= largeur image
               move.b    (a0)+,d4                 ;d4= hauteur image

SL_DWN         move.w    d3,d1                    ;d1= compt boucle ligne
               movea.l   a2,a3                    ;a3= adr zone  crire

SL_LINE        move.b    (a0)+,(a3)+              ;Transfert 1 octet
               dbf       d1,SL_LINE               ;Ligne acheve ?
               adda.l    #$80,a2                  ;Oui, ligne suivante
               dbf       d4,SL_DWN                ;Image acheve ?
               movea.l   (a7)+,a0                 ;Restitue val a0
               move.l    (a7)+,(a0)               ;Restitue adr(a0)
               subq.l    #$01,d7                  ;Si d7=1 rend mm  SB
               beq.s     LIBERE                   ;Si d7=0 fin procdure
               rts

LIBERE         moveq     #MT.RECHP,d0             ;mmoire rendue  SB
               trap      #$01                     ;si commande SLOAD
               rts                                ;on passe  autre chose

SMOVE          clr.l     d6
               bsr.s     INFO_VS                  ;Cherche info gnrale
               bne       EXIT                     ;Rien d'intressant...
               cmpi.w    #$02,d3                  ;Garon ! 2 paramtres
               beq.s     DEUX_PAR                 ;OK !  marche...
               bmi       ERR.BP                   ;Oui mais pas moins...
               subi.w    #$04,d3                  ;Ah ! il y en a 4 ?
               bne       ERR.BP                   ;Non ? carton jaune...
               moveq     #$01,d6                  ;d6= flag 4 paramtres

DEUX_PAR       move.l    $00(a6,a1.l),d1          ;Quel cran demand ?
               bmi       ERR.BP                   ;d1 positif, h patate !
               beq.s     SC_OK                    ;ECR0 demand...
               cmp.w     d1,d7                    ;Ecran demand valide ?
               bpl.s     SC_OK                    ;Oui ? wonderful...
               clr.l     d1                       ;Non ? alors ECR0 et
               bsr       ERR.NF                   ;message err et suite

SC_OK          mulu      #$8000,d1                ;ptr relatif db ECR0/1
               addi.l    #$20000,d1               ;ptr absolu db ECR0/1
               move.l    d1,d3                    ;Mmorise adr db cran
               movea.l   $04(a6,a1.l),a0          ;a0= adr=SSAVE(x,y,l,h)
               move.l    (a0),-(a7)               ;Place adr(a0)/ SP
               move.l    a0,-(a7)                 ;Place val a0/ SP
               move.l    (a0),d2                  ;d2= adr db bloc cran
               subi.l    #$20000,d2               ;d2= offset cran
               cmpi.l    #$8000,d2                ;Est-ce offset ECR1 ?
               bmi.s     OK_ECR0                  ;Non ! offset relatif
               subi.l    #$8000,d2                ;Cherche offset relatif

OK_ECR0        add.l     d1,d2                    ;d2= adr dbut bloc
               move.l    d2,(a0)                  ;(a0)= adr db bloc
               clr.l     d7                       ;d7= 0 (vite dsastre)
               subi.w    #$01,d6                  ;2 ou 4 paramtres ?
               bne       SC_MOVE                  ;Affiche le bloc
               exg       d3,d7                    ;d7= db cran demand
               move.l    $08(a6,a1.l),d1          ;d1= X pos
               bmi       PAS_BON                  ;Positif svp...
               move.l    $0C(a6,a1.l),d2          ;d2= Y pos
               bmi       PAS_BON                  ;Positif svp...
               move.l    (a0)+,d4                 ;Incrment a0 4 octets
               clr.l     d4                       ;et pointe lb & hb
               move.b    (a0)+,d3                 ;d3= largeur bloc
               move.b    (a0)+,d4                 ;d4= hauteur bloc
               move.l    #$0200,d6                ;d6= largeur max cran
               sub.l     d1,d6                    ;Xpos < d6 ?(d6=512-d1)
               bmi       PAS_BON                  ;Non ? farfelu va !
               move.l    d3,-(a7)                 ;Prserve d3
               addq.w    #$01,d3                  ;d3= largeur / 4 + 1
               lsl.l     #$02,d3                  ;d3= largeur * 4
               sub.l     d3,d6                    ;Xpos + largeur < 512 ?
               bpl.s     X_OK                     ;OK !  rentre...
               move.l    #$0200,d6                ;Xpos trop  droite
               sub.l     d3,d6                    ;d6= 512 - largeur
               move.l    d6,d1                    ;d1= Xpos autoris

X_OK           move.l    (a7)+,d3                 ;Rtablissement d3
               move.l    #$0100,d6                ;d6= hauteur max cran
               sub.l     d2,d6                    ;Ypos < d6 ?(d6=256-d2)
               bmi       PAS_BON                  ;Non ? abattez-le !
               move.l    d4,-(a7)                 ;Prserve d4
               addq.w    #$01,d4                  ;d4= hauteur - 1
               sub.l     d4,d6                    ;Ypos + hauteur < 256 ?
               bpl.s     Y_OK                     ;OK ! tout bon !
               move.l    #$0100,d6                ;Ypos trop bas
               sub.l     d4,d6                    ;d6= 256 - hauteur
               move.l    d6,d2                    ;d2= Ypos autoris

Y_OK           move.l    (a7)+,d4                 ;Rtablissement d4
               lsr.l     #$02,d1                  ;X/4
               lsl.l     #$07,d2                  ;Y*128
               add.l     d1,d2                    ;d1+d2 offset db bloc
               add.l     d7,d2                    ;d2 adr dbut affichage
               movea.l   (a7),a0                  ;Restitue val a0
               move.l    d2,(a0)                  ;(a0)= dbut affichage
               clr.l     d7                       ;Evite dsastre
               movea.l   (a0)+,a2                 ;a2= offset ligne
               move.w    (a0)+,d6                 ;incrment (a0) 2 octets
               bra       SL_DWN                   ;Affiche le bloc

PAS_BON        movea.l   (a7)+,a0                 ;Dpile SP val a0
               move.l    (a7)+,(a0)               ;Dpile SP adr(a0)
               bra       ERR.OR                   ;et alerte rouge...

SSAVE          clr.l     d7
               bsr       INFO_VS
               bne       EXIT                     ;Maldone !
               movea.l   a1,a2                    ;Prserve a1
               cmpi.w    #$05,d3                  ;Et 5 paramtres... 5 !
               beq.s     CINQ_PAR                 ;OK ! il y en a 5

QUAT_PAR       subq.w    #$04,d3                  ;4 paramtres ?
               bne       ERR.BP                   ;Non ! problme...
               subq.l    #$04,a2                  ;Triche ptr adr db pile
               clr.l     d6                       ;Cherche cran actif
               move.b    SV.MCSTA(a4),d6          ;(a4 = adr var sys) et
               lsr.b     #$07,d6                  ;vire bits inutiles et
               bra.s     SC_OKEY                  ;agit comme avec 5 param

CINQ_PAR       move.l    $00(a6,a2.l),d6          ;d6= switch cran dsir
               bmi       ERR.BP                   ;d6 positif h galopin !
               beq.s     SC_OKEY                  ;Ecran 0 demand
               cmp.l     d6,d7                    ;Ecran demand valide ?
               bpl.s     SC_OKEY                  ;Oui ? it's perfect
               clr.l     d6                       ;Non ? alors ECR0 et
               bsr       ERR.NF                   ;message err et suite

SC_OKEY        mulu      #$8000,d6                ;d6= offset db ECR0/1
               addi.l    #$20000,d6               ;d6= db cran demand
               move.l    $04(a6,a2.l),d1          ;d1= X pos
               bmi       ERR.OR                   ;Un peu trop  gauche
               move.l    $08(a6,a2.l),d2          ;d2= Y pos
               bmi       ERR.OR                   ;Un peu trop haut
               move.l    $0C(a6,a2.l),d3          ;d3= largeur X
               bmi       ERR.OR                   ;De gauche  droite svp
               beq       ERR.BP                   ;et non nul... rigolo !
               move.l    $10(a6,a2.l),d4          ;d4= hauteur Y
               bmi       ERR.OR                   ;De haut en bas ! @*# !
               beq       ERR.BP                   ;non nul ! spsdeuk !!!
               move.l    #$0200,d5                ;d5= largeur max cran
               sub.l     d1,d5                    ;512 - Xpos
               sub.l     d3,d5                    ;largeur + Xpos < 512
               bmi       ERR.OR                   ;Non ! a va coincer...
               move.l    #$0100,d5                ;d5= hauteur max cran
               sub.l     d2,d5                    ;256 - Ypos
               sub.l     d4,d5                    ;hauteur + Ypos < 256
               bmi       ERR.OR                   ;Non ! a passera pas !
               lsr.l     #$02,d1                  ;d1= Xpos / 4
               lsl.l     #$07,d2                  ;d2= Ypos * 128
               add.l     d1,d2                    ;= offset cran
               add.l     d6,d2                    ;= dbut cran + offset
               lsr.l     #$02,d3                  ;d3= largeur / 4
               beq       ERR.OR                   ;On a du se planter...
               move.l    d3,d1                    ;Prserve val d3
               mulu      d4,d1                    ;Calcule surface octets
               addq.l    #$06,d1                  ;+ 6 octets infos block
               exg       d0,d6                    ;Prserve message err
               clr.l     d0                       ;et nettoie d0
               movem.l   d2-d3/a1/a3,-(a7)        ;On prserve les regs
               moveq     #$00,d2                  ;et rserve la mmoire
               moveq     #MT.ALCHP,d0             ;ncessaire...
               trap      #$01
               movem.l   (a7)+,d2-d3/a1/a3        ;On dpile
               tst.l     d0                       ;Y a-t'il une erreur ?
               bne       EXIT                     ;Oui ! Sortez-le...
               subq.w    #$01,d3                  ;d3= largeur -1
               subq.w    #$01,d4                  ;d4= hauteur -1
               move.l    a0,-(a7)                 ;Prserve a0
               move.l    d2,(a0)+                 ;Ecrit offset cran
               move.b    d3,(a0)+                 ;Ecrit largeur
               move.b    d4,(a0)+                 ;Ecrit hauteur
               movea.l   d2,a2                    ;Offset cr = adr dbut

SS_LDWN        move.w    d3,d1                    ;Init compteur longueur
               movea.l   a2,a3                    ;Init compteur hauteur

SS_LINE        move.b    (a3)+,(a0)+              ;Octet RAM = octet VRAM
               dbf       d1,SS_LINE               ;Fin ligne ?
               adda.l    #$80,a2                  ;Oui ? ligne suivante
               dbf       d4,SS_LDWN               ;dernire ligne ?
               move.l    (a7)+,d4                 ;Oui ? d4 = adr (a0)
               moveq     #$10,d1                  ;et attaque rtn val_fnc
               adda.l    d1,a1                    ;a1+16 (ptr pile arith)

; Cette rtn transforme un entier long en nb  virgule flottante

VAL_FNC        move.l    a1,BV.RIP(a6)            ;Prserve ptr pile arit
               moveq     #$06,d1                  ;1 nb virg flottante et
               movea.w   BV.CHRIX,a2              ;lui rserve place
               jsr       (a2)                     ;(6 octets)
               movea.l   BV.RIP(a6),a1            ;Ptr pile arit actualis
               subq.l    #$06,a1                  ;6 oct pour virg flot
               clr.w     $00(a6,a1.l)             ;Nettoie exposant
               tst.l     d4                       ;Valeur nulle ?
               beq.s     NO_VAL                   ;Oui ! tout simple
               move.w    #$0820,d2                ;d2= $81F (cf rtn arith)

SET_VALF       subq.w    #$01,d2                  ;Puisque j'vous l'dit !
               asl.l     #$01,d4                  ;d4*2 (exp binaire)
               bvc.s     SET_VALF                 ;Change de signe ?
               roxr.l    #$01,d4                  ;d4/2 (cf rtn arith)
               move.w    d2,$00(a6,a1.l)          ;Ret val exposant

NO_VAL         move.l    d4,$02(a6,a1.l)          ;Ret val mantisse
               move.l    a1,BV.RIP(a6)            ;Reset pile arith
               moveq     #$02,d4                  ;Fixe type (virg flot)

; d6 sert ici  mmoriser une erreur non critique en cours de droulement
; cran 1 demand n'existant pas par exemple. Il est postul dans ce cas
; qu'il s'agit d'une erreur de frappe et afin de ne pas perdre de donnes
; tout se passe comme si l'cran 0 tait demand. En fin d'action un
; message signale toutefois qu'une erreur est intervenue. Ceci pertube
; cependant l'affichage mais aprs la mmorisation. Il est donc possible
; de restauter l'cran initial et de recommencer la commande, soit en mode
; direct, soit par le biais d'un WHEN ERROR (QL MG & JS(L1) seulement).

               move.l    d6,d0                    ;Y-a-t'il une erreur ?
EXIT           rts                                ;Bin non ! Chouette !!!

EXIT.OK        moveq     #$00,d0                  ;Retour sans erreur
               rts

; Messages d'erreur

ERR.OR         moveq     #-$04,d0                 ;Sortie des limites
               rts

ERR.NF         moveq     #-$07,d0                 ;Pas trouv
               rts

ERR.BP         moveq     #-$0F,d0                 ;Mauvais paramtre
               rts

; Nom du programme

               dc.l      $4AFB000A
               dc.b      'ECMAN v0.20 0808',$0A
               dc.b      'J.Tripodi - 1991',$0A

; Dfinition proc. & fonc.

DEF_PRFN       dc.w      $05                      ;5 procdures
               dc.w      SCROF-*
               dc.b      5,'SCROF'
               dc.w      SCRON-*
               dc.b      5,'SCRON'
               dc.w      SLOAD-*
               dc.b      5,'SLOAD'
               dc.w      SMOVE-*
               dc.b      5,'SMOVE'
               dc.w      SSHOW-*
               dc.b      5,'SSHOW'
               dc.w      $00
               dc.w      $02                      ;2 fonctions
               dc.w      SSAVE-*
               dc.b      5,'SSAVE'
               dc.w      SSTAT-*
               dc.b      5,'SSTAT'
               dc.w      $00

               END
