* routine de point graphique,appelable avec des coordonnes 
* graphiques et non par des positions a l'cran en pixels
* mise au point le 27 nov 88
*---------------------------
* cette procdure est calque sur celle de l'tablissement du
* curseur graphique en ce qui concerne les calculs:
* --placement similaire des paramtres en pile arithmtique
* --table d'oprations comparable,mais adapte
*---------------------------
* syntaxe de la commande:   GPOINT (#canal,) x, y 
* le canal par dfaut sera le #1
*---------------------------
AAA      bra.s procinit
         dc.b  'D.Vincent nov 88'
         dc.w  $4afb
         dc.b  6,'GPOINT',0
procinit lea  PROCTAB,a1
         move.w $110,a2
         jsr (a2)
         moveq #0,d0
          rts
*----------------------------                   
PROCTAB  dc.w 1
         dc.w GPNT-*
         dc.b 6,'GPOINT',0
         dc.w 0,0,0
*=====--------routine---------=====          
GPNT     cmpa.l a3,a5     ;y a t-il des paramtres? 
         beq   RETOUR1
         jsr   $65E4     ; rech_id_canal(dfaut: #1) 
         move.l a0,-(a7) ; range l'ID du canal
         move.l a2,-(a7)
         lea PILAR,a1    ; 80 octets reservs en PILE ARITHM.
         suba.l  a6,a1   ; a1 relatif  a6 pour vecteurs QDOS
         move.w  $114,a2 ; recherche des flottants
         jsr     (a2)    ;empile les paramtres
         bne     RETOUR0
         movea.l (a7)+,a2
         move.l (a7)+,d6 ; id enregistr dans d6
         tst.b  d3
         beq     RETOUR1
         subq.w  #1,d3 
         beq     RETOUR1    ; 2 paramtres : x et y
         move.l 0(a6,a1.l),10(a6,a2.l) ;replace coordonnes graph.
         move.w 4(a6,a1.l),14(a6,a2.l) ;dans le canal basic QDos
         move.l 6(a6,a1.l),4(a6,a2.l)  ;point par a2,en inversant
         move.w 10(a6,a1.l),8(a6,a2.l) ;les 2 flottants->4(a2)->>
         moveq #0,d7
         move.w  d6,d7
         lsl.w  #2,d7       ; num_canal * 4
         movea.l $28078,a2
         add.l d7,a2
         movea.l (a2),a0    ;a0 pointe le descr_canal
         moveq #0,d7        ;d7=0 pour la suite des calculs
         add.l  #12,a1    
         move.l a1,a4      ;a4 pte le haut des 2 variables
         subq.w  #1,d3
         bne   RETOUR1
STACK    sub.l  #12,a1                    
         move.l $52(a0),-4(a6,a1.l)  ;empile origines graphiques
         move.l $4E(a0),-8(a6,a1.l)  ;hor. et verticale
         sub.l  #18,a1
         move.l $4A(a0),6(a6,a1.l)   ;dans la fentre( 2 flottants)
         move.l  $229C,2(a6,a1.l)    ;empile le nombre
         move.w  $229A,0(a6,a1.l)    ; 1.355
         subq.w  #2,a1      ;aprs conversion ,a1 maj  -4 !
         move.w  $1E(a0),0(a6,a1.l)
         subq.w  #1,0(a6,a1.l)       ;empile haut-fentre moins 1
         moveq   #8,d0               ;conv en flottant
         jsr     $419A
         move.l  $58(a0),-4(a6,a1.l) ;empile chelle graphique
         move.w  $56(a0),-6(a6,a1.l) ;en cours dans le canal
         subq.w  #6,a1                                              
CALCULS  lea  TABLOP,a3    ; $1E48  = table op en ROM        
         jsr   $41A2       ;xcute suite d'oprations
         bra.s  CONVER
TABLOP   dc.b $12         
         dc.b $10
         dc.b $16
         dc.b $FA
         dc.b $E8
         dc.b $0C
         dc.b $0E 
         dc.b $FB
         dc.b $F4
         dc.b $EE
         dc.b $0C
         dc.b $0E
         dc.b $0E
         dc.b $F5
         dc.w 0  
CONVER   add.l #$C,a1
         moveq #2,d0       ;conv en entier abscisse(pixel)
         jsr   $419A
         move.w 0(a6,a1.l),d1
         tst.w d1
         bmi   RETOUR
         cmp.w $1C(a0),d1  ;verif. si affichable
         bgt   RETOUR
         addq.w  #2,a1
         moveq  #2,d0
         jsr   $419A         ;conv flot. suivant
         move.w $1E(a0),d2   ;d2 = hauteur de la fentre
         subq #1,d2          ; ... moins 1 
         sub.w 0(a6,a1.l),d2 ;sens inverse pour ordonne(pixel)
         bmi   RETOUR
         cmp.w  $1E(a0),d2   ;verif. si affichable
         bgt   RETOUR   
         add.w  $18(a0),d1 ;ajoute orig.h fentre
         add.w  $1A(a0),d2 ;ajoute orig.v fentre  d2              
* traitement de la mmoire-cran selon coordonnes en points
* relatives  l'cran,contenues dans d1 (x) et d2 (y)           
PIXW     move.b $46(a0),d3   ; couleur en cours   
         mulu  #$80,d2
         add.l #$20000,d2
         move.w d1,d4
         and.b #7,d4
         lsr.l #3,d1
         lsl.l #1,d1
         add.l d1,d2
         movea.l d2,a0
         sub.l d1,d1
         btst #3,$28034 ;test resolution cran
         beq   MODE4
         and.b  #6,d4
         bsr.s  MASQUE
         subq.b #1,d2
         bclr   d2,(a0)+
         bra.s  SUITE
MODE4    and.b  #6,d3
         bsr.s  MASQUE
         addq.l #1,a0
SUITE    move.b d3,d1
         and.b  #4,d1
         lsl.w  #5,d1
         lsl.w  #8,d1
         lsr.w  d4,d1
         move.b d3,d1
         and.b  #3,d1
         lsl.b  #6,d1
         lsr.b  d4,d1
         or.w  d1,-(a0)                   
RETOUR   moveq #0,d0
          rts
RETOUR0  add.l #4,a7
         moveq #-15,d0
          rts
RETOUR1  sub.l a0,a0
         moveq #-1,d3
         lea MESS,a1    ; message d'aide dans le canal 0
         move.w $D0,a2
         jsr (a2)
         moveq #0,d0
          rts
*-------           
MASQUE   moveq  #7,d2
         sub.b  d4,d2
         bclr   d2,(a0)+
         bclr   d2,(a0)
          rts
*-------
MESS     dc.w 47
         dc.b '2 paramtres: abscisse et ordonne graphiques.',10,0
PILAR    ds.l $50   ; pile arithmtique personnelle          
         end AAA
                              
