;Hardcopy of the HGRscreen
;initialising the procedure HCO
        LEA     DEFPRO,A1
        MOVE.W  $110,A2
        JSR     (A2)
        RTS
DEFPRO: DC.W    11
        DC.W    HCO-*
        DC.B    3,'HCO'
        DC.W    SET-*
        DC.B    3,'SET'
        DC.W    FCO-*
        DC.B    3,'FCO'
        DC.W    BICOP-*
        DC.B    5,'BICOP'
        DC.W    BMOVE-*
        DC.B    5,'BMOVE'
        DC.W    LDRAW-*
        DC.B    5,'LDRAW'
        DC.W    PAINT-*
        DC.B    5,'PAINT'
        DC.W    GETXY-*
        DC.B    5,'GETXY'
        DC.W    INVXY-*
        DC.B    5,'INVXY'
        DC.W    XDRAW-*
        DC.B    5,'XDRAW'
        DC.W    DOTLIN-*
        DC.B    6,'DOTLIN',0
        DC.W    0
        DC.W    2
        DC.W    COL-*
        DC.B    3,'COL'
        DC.W    BLOOK-*
        DC.B    5,'BLOOK'
        DC.W    0
SER1HR: DC.W    6
        DC.B    'SER1HR'
PREAMB: DC.W    5
        DC.B    27,'@',27,'A',7,0
SNGDAT: DC.W    10
        DC.B    10,'     ',27,'K',0,2
GRADAT: DC.W    10
        DC.B    10,'     ',27,'L',0,4
POSTAB: DC.W    2
        DC.B    27,'@'
;Ausgabe von D1 nach channel (A0)
; A5 is pointer to IO buffer, D5 is Buffer running pointer
OUTD1:  MOVEM.L D0/D1/D3/A1,-(A7)
        MOVE.B  D1,0(A5,D5)
        ADDQ.W  #1,D5
        CMP.W   #2048,D5
        BNE.S   OUTD1R
        CMP.W   #27,$2808A
        BEQ.S   NOOUT
        MOVE.W  D5,D2   ;number of bytes
        MOVE.L  A5,A1   ;Buffer
        MOVE.W  #-1,D3   ;Wait for complete
        MOVEQ   #6,D0   ;IO.SSTRG
        TRAP    #3
NOOUT:  MOVEQ   #0,D5   ;reset buffer running pointer
OUTD1R: MOVEM.L (A7)+,D0/D1/D3/A1
        RTS
;Ausgabe eines Strings (A1) nach channel (A0)
PRINT:  MOVEM.L D0/D2/A1,-(A7)
        MOVE.W  (A1)+,D2
        SUBQ.W  #1,D2
PRTLOP: MOVE.B  (A1)+,D1
        BSR.S   OUTD1
        DBF     D2,PRTLOP
        MOVEM.L (A7)+,D0/D2/A1
        RTS
FCO:    MOVEQ   #1,D4   ;Flag for single density
        BRA.S   DOCO
HCO:    MOVEQ   #0,D4   ;Flag for double density
DOCO:   BSR     INISER
        MOVEQ   #0,D7   ;Row number
ROW:    LEA     GRADAT,A1
        TST.B   D4
        BEQ.S   PRTDBL
        LEA     SNGDAT,A1
PRTDBL: BSR     PRINT   ;Start bitimage sequenz
        MOVEQ   #0,D6   ;Columnnumber
COLUMN: EOR.L   D1,D1
        MOVEQ   #7,D2   ;Counter
DOT:    BSR     COLOUR
        LSL.B   #1,D1
        BTST    #0,D3   ;One colour
        BEQ     NOTGRN
        OR.B    #1,D1
NOTGRN: SWAP    D1      ;Other colour
        LSL.B   #1,D1
        BTST    #1,D3
        BEQ     NOTRED
        OR.B    #1,D1
NOTRED: SWAP    D1
        ADDQ.W  #1,D7 ;Next Row same column
        DBF     D2,DOT
        SUBQ.W  #8,D7   ;Rownumber wiederherstellen
        TST.B   D4
        BEQ.S   OUTDBL
        MOVE.B  D1,D2
        SWAP    D1
        OR.B    D2,D1
        BRA.S   OUTSNG
OUTDBL: BSR     OUTD1
        SWAP    D1
OUTSNG: BSR     OUTD1
        ADDQ.W  #1,D6   ;Next column
        CMP.W   #512,D6
        BLT     COLUMN
        BSR.S   FLUSH
        ADDQ.W  #8,D7   ;Next row
        CMP.W   #256,D7
        BLT     ROW
;Reset Printer
FINSER: LEA     POSTAB,A1
        BSR     PRINT
; Flush buffer
        BSR.S   FLUSH
; Close channel
        MOVEQ   #2,D0
        TRAP    #2
        MOVEQ   #0,D0
; release common heap
        MOVE.L  A5,A0
        MOVEQ   #$19,D0
        TRAP    #1
RETURN: RTS
FLUSH:  MOVEM.L D0-D4/A0-A4,-(A7)
        CMP.W   #27,$2808A
        BEQ.S   NOOUT2
        MOVE.L  A5,A1   ;Buffer
        MOVE.L  D5,D2   ;number of bytes
        MOVEQ   #-1,D3  ;wait for complete
        MOVEQ   #7,D0   ;IO.SSTRG
        TRAP    #3
NOOUT2: MOVEQ   #0,D5
        MOVEM.L (A7)+,D0-D4/A0-A4
        RTS
INISER: MOVEQ   #$18,D0 ;MT.ALCHP
        MOVEQ   #0,D2   ;Job ID
        MOVE.L  #2048,D1 ;number of Bytes
        TRAP    #1      ;allocate heap
        MOVE.L  A0,A5   ;A5 holds address
        MOVEQ   #0,D5   ;D5 is buffer running pointer
;Now open SER1hr
        MOVEQ   #0,D1   ;Job ID
        MOVEQ   #0,D3   ;Old (exclusive) device
        LEA     SER1HR,A0
        MOVEQ   #1,D0   ;IO.OPEN
        TRAP    #2
        LEA     PREAMB,A1
        BSR     PRINT   ;Initialise printer
        RTS
BICOP:  BSR.S   INISER
        MOVE.L  #$2007E,A2
NXTCOP: LEA     SNGDAT,A1
        BSR     PRINT   ;Start Bitimage sequenz
        EOR.L   D2,D2
NXTCLM: MOVE.B  0(A2,D2.L),D1   ;First colour Byte
        BSR.S   INVD1
        BSR     OUTD1
        MOVE.B  1(A2,D2.L),D1   ;Second colour byte
        BSR     INVD1
        BSR     OUTD1
        ADD.L   #128,D2         ;Next Byte
        CMP.L   #$8000,D2       ;End of Screen ?
        BLT.S   NXTCLM
        BSR.S   FLUSH
        SUBQ.L  #2,A2           ;Next row
        CMP.L   #$20000,A2
        BGE.S   NXTCOP
        BRA     FINSER
INVD1:  MOVEM.L D0/D2,-(A7)
        MOVEQ   #7,D2
DOINV:  ROXR.B  #1,D1
        ROXL.B  #1,D0
        DBRA    D2,DOINV
        MOVE.B  D0,D1
        MOVEM.L (A7)+,D0/D2
        RTS
;Punkt Plot und point routinen
;
;PLOT X=D6,Y=D7 with colour D3 in High resolution
PLOT:   MOVEM.L D0/D3/A0,-(A7)
        BSR     GETAD0
        BSR.S   ANDD3
        AND.W   D0,D3
        NOT.W   D0
        AND.W   D0,(A0)
        OR.W    D3,(A0)
        MOVEM.L (A7)+,D0/D3/A0
        RTS
ANDD3:  MOVE.L  A1,-(A7)
        LEA     DATAND,A1
        AND.L   #3,D3
        ADD.B   D3,D3
        MOVE.W  0(A1,D3),D3
        MOVE.L  (A7)+,A1
        RTS
DATAND: DC.W    $0
        DC.W    $FF
        DC.W    $FF00
        DC.W    $FFFF
;D3=Colour(D6,D7)
COLOUR: MOVEM.L D6/D7/A0,-(A7)
        LSL.L   #7,D7 ;*128
        BSET    #17,D7 ;+$20000
        MOVE.L  D7,A0
        MOVE.L  D6,D7
        LSR.W   #2,D7
        BCLR    #0,D7
        ADD.L   D7,A0
        MOVEQ   #$7,D7
        AND.W   D7,D6
        SUB.W   D6,D7
        MOVEQ   #2,D3
        BTST    D7,(A0)+
        BNE.S   TESODD
        MOVEQ   #0,D3
TESODD: BTST    D7,(A0)
        BEQ.S   RET
        ADDQ.W  #1,D3
RET:    MOVEM.L (A7)+,D6/D7/A0
        RTS
;X=D6,Y=D7 Address.L -> A0,Mask.W -> D0
GETAD0: MOVEM.L D6/D7,-(A7)
        AND.L   #$FF,D7
        MULU    #128,D7
        ADD.L   #$20000,D7
        MOVE.L  D7,A0
        AND.L   #$1FF,D6
        MOVE.L  D6,D7
        LSR.W   #2,D7
        BCLR    #0,D7
        ADD.L   D7,A0
        MOVE.W  #$8080,D0
        AND.W   #$7,D6
        LSR.W   D6,D0
        MOVEM.L (A7)+,D6/D7
        RTS
;FPLOT like PLOT, but you have to call ANDD3 first,D6 and D7 are long !!
FPLOT:  MOVEM.L D3/D6/D7/A0,-(A7)
        LSL.L   #7,D7
        BSET    #17,D7
        MOVE.L  D7,A0
        MOVE.L  D6,D7
        LSR.W   #2,D7
        BCLR    #0,D7
        ADD.L   D7,A0
        MOVE.W  #$8080,D7
        AND.W   #$7,D6
        LSR.W   D6,D7
        AND.W   D7,D3
        NOT.W   D7
        AND.W   D7,(A0)
        OR.W    D3,(A0)
        MOVEM.L (A7)+,D3/D6/D7/A0
        RTS
;BASIC procedure SET X,Y,C set point X,Y with colour C
SET:    MOVE.W  $112,A2
        JSR     (A2)    ;Get integer parameter
        MOVE.W  4(A6,A1.L),D3   ;Colour
        MOVE.W  2(A6,A1.L),D7   ;Y
        MOVE.W  0(A6,A1.L),D6   ;X
        BSR     PLOT
        MOVEQ   #0,D0
        RTS
;BASIC Function Colour=COL(X,Y) returns the colour of the pixel X,Y
COL:    MOVE.W  $112,A2
        JSR     (A2)    ;Get integer parameter
        MOVE.W  2(A6,A1.L),D7   ;Y
        MOVE.W  0(A6,A1.L),D6   ;X
        BSR     COLOUR
        ADDQ.L  #2,A1
        MOVE.W  D3,0(A6,A1.L)
        MOVE.L  A1,$58(A6)
        MOVEQ   #3,D4   ;Integer return
        MOVEQ   #0,D0
        RTS
;BASIC procedure Blockmove BMOVE A,B,C moves the memory
;beginning with A ending with B to location C
BMOVE:  MOVE.W  $118,A2 ;Get long integer parameter
        JSR     (A2)
        MOVE.L  0(A6,A1.L),A2
        MOVE.L  4(A6,A1.L),D0
        MOVE.L  8(A6,A1.L),A3
        SUB.L   A2,D0
        CMPA.L  A2,A3
        BMI.S   INC
        ADDA.L  D0,A2
        ADDA.L  D0,A3
DEC:    MOVE.B  -(A2),-(A3)
        DBF     D0,DEC
        MOVEQ   #0,D0
        RTS
INC:    MOVE.B  (A2)+,(A3)+
        DBF     D0,INC
        MOVEQ   #0,D0
        RTS
;BASIC function ADR=BLOOK(STRING$,START,END) returns the first occurence
;of STRING$ betwen START and END address or Zero if the string is not 
;found.
BLOOK:  MOVE.W  $116,A2 ;Get strings from Basic
        MOVE.L  A3,A5
        ADDQ.L  #8,A5 ;only one string is required
        JSR     (A2)
        MOVE.L  A1,-(A7) ;Store pointer to string
        ADDQ.L  #8,A3
        ADD.L   #16,A5 ;Two long integerparameter were needed
        MOVE.W  $118,A2
        JSR     (A2)
        MOVE.L  0(A6,A1.L),A0 ;start
        MOVE.L  4(A6,A1.L),D0 ;end
        MOVE.L  (A7)+,A1 ;pointer to string
        LEA     2(A6,A1.L),A2 ;A2=Pointer to text
        MOVE.W  0(A6,A1.L),D2 ;D2=length of string
TRYNEX: MOVEQ.L #0,D1 ;offset
COMPAR: MOVE.B  0(A2,D1),D3
        CMP.B   0(A0,D1),D3
        BNE.S   WARNIX
        ADDQ.L  #1,D1
        CMP.W   D1,D2
        BNE.S   COMPAR
        MOVE.L  A0,D0
        BRA     RETLI
WARNIX: ADDQ.L  #1,A0
        CMP.L   A0,D0
        BCC.S   TRYNEX
        MOVEQ.L #0,D0
RETLI:  BSR.S   LITOFP
        MOVE.L  A1,$58(A6)
        MOVEQ   #2,D4   ;Floating point return
        MOVEQ   #0,D0
        RTS
LITOFP: MOVEQ   #0,D2           ;Try Zero
        TST.L   D0
        BEQ.S   STOFP           ;Long Integer D0
        MOVE.W  #$81F,D2        ;nach Floatingpoint (A6,A1.L)
CONLP:  BTST    #30,D0          ;Transformieren
        BNE.S   STOFP
        LSL.L   #1,D0
        SUBQ.W  #1,D2
        BRA     CONLP
STOFP:  MOVE.W  D2,0(A6,A1.L)
        MOVE.L  D0,2(A6,A1.L)
        RTS
;Basicprocedure LDRAW x1,y1,x2,y2,c draws a line from x1,y1 to x2,y2
;using the colour c
LDRAW:  MOVE.W  $112,A2
        JSR     (A2)    ;Get integer parameter
        MOVE.W  8(A6,A1.L),D3   ;Colour
        MOVE.W  6(A6,A1.L),D7   ;Y2
        MOVE.W  4(A6,A1.L),D6   ;X2
        MOVE.W  2(A6,A1.L),D5   ;Y1
        MOVE.W  0(A6,A1.L),D4   ;X1
        BSR.S   LINE
        MOVEQ   #0,D0
        RTS
;Draw line from X=D4,Y=D5 to X=D6,Y=D7 with colour D3
LINE:   MOVEM.L D0-D7/A0-A6,-(A7)
        BSR     ANDD3
        AND.L   #$1FF,D6
        AND.L   #$1FF,D4
        AND.L   #$FF,D7
        AND.L   #$FF,D5
        MOVEQ   #1,D0           ;X Increment
        MOVEQ   #1,D1           ;Y Increment
        MOVE.L  D6,D2
        SUB.L   D4,D2           ;A0=X2-X1
        BCC.S   RIGHT
        NEG.L   D2              ;A0=ABS(X2-X1)
        SUBQ.W  #2,D0           ;X Decrement
RIGHT:  MOVE.L  D2,A0
        MOVE.L  D7,D2
        SUB.L   D5,D2           ;A1=Y2-Y1
        BCC.S   DOWN
        NEG.L   D2              ;A1=ABS(Y2-Y1)
        SUBQ.W  #2,D1           ;Y Decrement
DOWN:   MOVE.L  D2,A1
        MOVE.L  A0,A2           ;Counter X
        MOVE.L  A1,A3           ;Counter Y
LINLOP: MOVEM.W D3/D4/D5,-(A7)
        LSL.L   #7,D5
        BSET    #17,D5
        MOVE.L  D5,A4
        MOVE.L  D4,D5
        LSR.W   #2,D5
        BCLR    #0,D5
        ADD.L   D5,A4
        MOVE.W  #$8080,D5
        AND.W   #$7,D4
        LSR.W   D4,D5
        AND.W   D5,D3
        NOT.W   D5
        AND.W   D5,(A4)
        OR.W    D3,(A4)
        MOVEM.W (A7)+,D3/D4/D5
        MOVE.W  D6,D2
        SUB.W   D4,D2           ;X2-X
        CMP.W   #-1,D2          ;-1 ?
        BEQ.S   XEQX2
        LSR.W   #1,D2           ;1 or 0 ?
        BNE.S   NXTLIN
XEQX2:  MOVE.W  D7,D2
        SUB.W   D5,D2           ;Y2-Y
        CMP.W   #-1,D2          ;-1 ?
        BEQ.S   YEQY2
        LSR.W   #1,D2           ;1 or 0 ?
        BEQ.S   YEQY2
NXTLIN: MOVE.L  A2,D2
        SUB.L   A3,D2
        BCC.S   XINC
        ADD.W   D1,D5
        ADD.L   A0,A2
        BRA.S   LINLOP
XINC:   ADD.W   D0,D4
        ADD.L   A1,A3
        BRA.S   LINLOP
YEQY2:  MOVEM.L (A7)+,D0-D7/A0-A6
        RTS
;Basic procedure PAINT X,Y,COLOUR,ADR,BYTES
;Paints the area around X,Y with Colour. ADR will be needed
;to store data. It should point to more then 4k of free memory.
;BYTES contains the number of bytes which can be used
PAINT:  MOVE.W  $118,A2
        JSR     (A2)            ;Get long integer parameters
        MOVE.L  16(A6,A1.L),D1  ;Number of free bytes
        SUBQ.L  #4,D1
        MOVE.L  12(A6,A1.L),A2  ;Pointer to free memory
        MOVE.L   8(A6,A1.L),D3  ;Paintingcolour
        MOVE.L   4(A6,A1.L),D7  ;Y
        MOVE.L   0(A6,A1.L),D6  ;X
        BSR.S   FILL
        MOVEQ   #0,D0
        RTS
;Paint the area around X=D6,Y=D7 with the colour D3 using D1 bytes
;of the memory pointed by A2
FILL:   MOVEM.L D0-D7/A0-A5,-(A7)
        MOVE.W  D3,-(A7)
        BSR     COLOUR          ;Get Backgroundcolour
        BSR     ANDD3
        MOVE.W  D3,D2           ;D2=Backgroundcolourmask
        MOVE.W  #$0101,D4       ;D4 holds this constant
        MOVE.W  (A7)+,D3
        BSR     ANDD3
        AND.L   #$1FF,D6
        AND.L   #$FF,D7
        LSL.L   #7,D7           ;Converting pixels into
        MOVE.L  D6,D0           ;Address (D7)
        LSR.W   #2,D0           ;and bitnumber (D6)
        BCLR    #0,D0
        ADD.L   D0,D7
        MOVEQ   #$7,D0
        AND.W   D0,D6
        SUB.W   D6,D0
        MOVE.W  D0,D6
        MOVE.L  #$20000,A0      ;Screenbase
        MOVE.L  #4,A3           ;(A2,A3.L) points to actual pixel
        MOVE.W  D6,(A2)         ;Bitnumber
        MOVE.W  D7,2(A2)        ;Address
DOFILL: SUBQ.W  #4,A3
        MOVE.W  0(A2,A3.L),D6   ;Bitnumber
        MOVE.W  2(A2,A3.L),D7   ;Address
        MOVE.W  D3,-(A7)        ;Farbe retten
        MOVE.W  D4,D0           ;set pixel
        LSL.W   D6,D0
        AND.W   D0,D3
        NOT.W   D0
        AND.W   D0,0(A0,D7.W)
        OR.W    D3,0(A0,D7.W)
        MOVEM.W D6/D7,-(A7)
        ADDQ.B  #1,D6           ;X-1
        AND.B   #7,D6           ;Bit overflow ?
        BNE.S   NOOVMI
        SUBQ.W  #2,D7           ;Lower address
NOOVMI: BSR.S   CMPCOL
        MOVEM.W (A7),D6/D7      ;Restore old values
        SUBQ.B  #1,D6           ;X+1
        BCC.S   NOOVPL
        MOVEQ   #7,D6           ;Bit 7
        ADDQ.W  #2,D7           ;Higher address
NOOVPL: BSR.S   CMPCOL
        MOVEM.W (A7)+,D6/D7     ;Restore old values
        ADD.W   #128,D7         ;Y+1
        BSR.S   CMPCOL
        SUB.W   #256,D7         ;Y-1
        BSR.S   CMPCOL
        MOVE.W  (A7)+,D3        ;Farbe
        CMP.W   #0,A3
        BNE.S   DOFILL
        MOVEM.L (A7)+,D0-D7/A0-A5
        RTS
CMPCOL: MOVE.W  D4,D0           ;D0=$0101
        MOVE.W  D2,D5           ;D5=Backgroundmask
        LSL.W   D6,D0
        AND.W   D0,D5
        AND.W   0(A0,D7.W),D0
        CMP.W   D0,D5           ;Colour(X,Y)=Backgroundcolour ?
        BEQ.S   SAVEXY
        RTS
SAVEXY: MOVE.W  D6,0(A2,A3.L)   ;Bitnumber
        MOVE.W  D7,2(A2,A3.L)   ;Address
        ADDQ.W  #4,A3
        CMP.L   D1,A3
        BCC.S   GARBAG
        RTS
;Garbage collection
GARBAG: MOVE.L  #0,A4           ;pointer for cleared table
        MOVE.L  A4,A5           ;pointer for old table
        SUBQ.L  #4,A3
COLECT: MOVE.W  0(A2,A5.W),D6   ;Bitnumber
        MOVE.W  2(A2,A5.W),D7   ;Address
        MOVE.W  D4,D0           ;D0=$0101
        MOVE.W  D2,D5           ;D5=Backgroundmask
        LSL.W   D6,D0
        AND.W   D0,D5
        AND.W   0(A0,D7.W),D0
        CMP.W   D0,D5           ;Colour=background ?
        BNE.S   NOMOVE
        MOVE.L  0(A2,A5.L),0(A2,A4.L)   ;X & Y together
        ADDQ.L  #4,A4           ;Updated table pointer
NOMOVE: ADDQ.L  #4,A5           ;Old table pointer
        CMP.W   A5,A3           ;End ?
        BCC.S   COLECT
        MOVE.W  0(A2,A3.L),D6
        MOVE.W  2(A2,A3.L),D7
        MOVE.L  A4,A3           ;Updating pointer
        CMP.L   D1,A3
        BCC.S   FAILED
        RTS
;through away every second pixel
FAILED: MOVE.L  #0,A4
        MOVE.L  A4,A5
        MOVE.L  D1,D0           ;Counter
        LSR.L   #3,D0           ;D0/8
        SUBQ.L  #4,D0
WASTE:  MOVE.L  0(A2,A5.L),0(A2,A4.L)
        ADDQ.L  #4,A4
        ADDQ.L  #8,A5
        DBF     D0,WASTE
        MOVE.L  A4,A3
        RTS
GETXY:  MOVE.W  $112,A2
        MOVEM.L A3-A5,-(A7)
        JSR     (A2)            ;Get integer parameter
        MOVEM.L (A7)+,A3-A5
        MOVE.W  2(A6,A1.L),D7   ;Y
        MOVE.W  0(A6,A1.L),D6   ;X
        BSR.S   CROSS
        MOVE.W  D7,2(A6,A1.L)   ;Return Y
        MOVE.W  D6,0(A6,A1.L)   ;Return X
        MOVE.L  A1,$58(A6)      ;BV.RIP
        MOVE.W  $120,A2         ;BP.LET
        JSR     (A2)
        ADDQ.L  #8,A3           ;Now return Y
        ADDQ.L  #2,A1
        MOVE.L  A1,$58(A6)
        JSR     (A2)
        MOVEQ   #0,D0
        RTS
;Crosshaircursor: start bei X=D6,Y=D7.
;Pfeile bewegen den cursor, space gibt koordinaten zurck
;Shift arrow means fast movement
CROSS:  MOVEM.L D0-D5/A0-A5,-(A7)
CURLOP: AND.L   #$FF,D7
        AND.L   #$1FF,D6
        BSR     INVERT
        MOVEQ   #-1,D3          ;Timeout
        MOVE.L  #0,A0           ;Keyboardchannel
        MOVEQ   #1,D0           ;IO.FBYTE
        TRAP    #3
        BSR     INVERT
        CMP.B   #$20,D1         ;Blank ?
        BNE.S   TESTUP
        MOVEM.L (A7)+,D0-D5/A0-A5
        RTS
TESTUP: CMP.B   #$D0,D1         ;Up ?
        BNE.S   TESTDN
        SUBQ.W  #1,D7
TESTDN: CMP.B   #$D8,D1         ;Down ?
        BNE.S   TESTLF
        ADDQ.W  #1,D7
TESTLF: CMP.B   #$C0,D1         ;Left ?
        BNE.S   TESTRG
        SUBQ.W  #1,D6
TESTRG: CMP.B   #$C8,D1         ;Right ?
        BNE.S   SHIFUP
        ADDQ.W  #1,D6
SHIFUP: CMP.B   #$D4,D1         ;Shift up ?
        BNE.S   SHIFDN
        SUBQ.W  #8,D7
SHIFDN: CMP.B   #$DC,D1         ;Shift down ?
        BNE.S   SHIFLF
        ADDQ.W  #8,D7
SHIFLF: CMP.B   #$C4,D1         ;Shift left ?
        BNE.S   SHIFRG
        SUBQ.W  #8,D6
SHIFRG: CMP.B   #$CC,D1         ;Shift right ?
        BNE     CURLOP
        ADDQ.W  #8,D6
        BRA     CURLOP
INVERT: MOVE.L  D6,D4
        MOVE.L  D7,D5
        MOVEQ   #-1,D3          ;Bitpattern for EOR
        MOVE.W  #31,D0          ;X-Count
        AND.L   #$1FF,D7
        LSL.W   #7,D7
        BSET    #17,D7
        MOVE.L  D7,A1
INVX:   EOR.L   D3,(A1)+
        DBF     D0,INVX
        MOVE.W  #0,D7           ;Y=0 simulieren
        BSR     GETAD0
        MOVE.W  #255,D3         ;Y-count
INVY:   EOR.W   D0,(A0)
        ADD.L   #128,A0
        DBF     D3,INVY
        MOVE.L  D4,D6
        MOVE.L  D5,D7
        RTS
;Basicprocedure INVXY X,Y xors a cross at X,Y
INVXY:  MOVE.W  $112,A2
        MOVEM.L A3-A5,-(A7)
        JSR     (A2)            ;Get integer parameter
        MOVEM.L (A7)+,A3-A5
        MOVE.W  2(A6,A1.L),D7   ;Y
        MOVE.W  0(A6,A1.L),D6   ;X
        BSR     INVERT
        MOVEQ   #0,D0
        RTS
;Basicprocedure XDRAW X1,Y1,X2,Y2 xors a line from X1,Y1 to X2,Y2
XDRAW:  MOVE.W  $112,A2
        JSR     (A2)    ;Get integer parameter
        MOVE.W  6(A6,A1.L),D7   ;Y2
        MOVE.W  4(A6,A1.L),D6   ;X2
        MOVE.W  2(A6,A1.L),D5   ;Y1
        MOVE.W  0(A6,A1.L),D4   ;X1
        BSR.S   XLINE
        MOVEQ   #0,D0
        RTS
;Draw line from X=D4,Y=D5 to X=D6,Y=D7 inverting colour
XLINE:  MOVEM.L D0-D7/A0-A6,-(A7)
        AND.L   #$1FF,D6
        AND.L   #$1FF,D4
        AND.L   #$FF,D7
        AND.L   #$FF,D5
        MOVEQ   #1,D0           ;X Increment
        MOVEQ   #1,D1           ;Y Increment
        MOVE.L  D6,D2
        SUB.L   D4,D2           ;A0=X2-X1
        BCC.S   XRIGHT
        NEG.L   D2              ;A0=ABS(X2-X1)
        SUBQ.W  #2,D0           ;X Decrement
XRIGHT: MOVE.L  D2,A0
        MOVE.L  D7,D2
        SUB.L   D5,D2           ;A1=Y2-Y1
        BCC.S   XDOWN
        NEG.L   D2              ;A1=ABS(Y2-Y1)
        SUBQ.W  #2,D1           ;Y Decrement
XDOWN:  MOVE.L  D2,A1
        MOVE.L  A0,A2           ;Counter X
        MOVE.L  A1,A3           ;Counter Y
XLLOP:  MOVEM.W D4/D5,-(A7)
        LSL.L   #7,D5
        BSET    #17,D5
        MOVE.L  D5,A4
        MOVE.L  D4,D5
        LSR.W   #2,D5
        BCLR    #0,D5
        ADD.L   D5,A4
        MOVE.W  #$8080,D5
        AND.W   #$7,D4
        LSR.W   D4,D5
        EOR.W   D5,(A4)
        MOVEM.W (A7)+,D4/D5
        MOVE.W  D6,D2
        SUB.W   D4,D2           ;X2-X
        CMP.W   #-1,D2          ;-1 ?
        BEQ.S   XXEQX2
        LSR.W   #1,D2           ;1 or 0 ?
        BNE.S   XNXLIN
XXEQX2: MOVE.W  D7,D2
        SUB.W   D5,D2           ;Y2-Y
        CMP.W   #-1,D2          ;-1 ?
        BEQ.S   XYEQY2
        LSR.W   #1,D2           ;1 or 0 ?
        BEQ.S   XYEQY2
XNXLIN: MOVE.L  A2,D2
        SUB.L   A3,D2
        BCC.S   XXINC
        ADD.W   D1,D5
        ADD.L   A0,A2
        BRA.S   XLLOP
XXINC:  ADD.W   D0,D4
        ADD.L   A1,A3
        BRA.S   XLLOP
XYEQY2: MOVEM.L (A7)+,D0-D7/A0-A6
        RTS
;Basicprocedure DOTLIN per1,per2,per3,col,X1,Y1,X2,Y2
;Draws a dots from X1,Y1 to X2,Y2 with colour col and the period
;per1=3: * , per2=3: $ , per3=2: #
;***$$$##$$$***$$$##...
DOTLIN: MOVEQ   #20,D1  ; 20 Bytes buffer needed
        MOVEQ   #0,D2   ; owned by basic
        MOVEQ   #$18,D0 ;MT.ALCHP
        TRAP    #1      ; allocate common heap
        MOVE.L  A0,-(A7)
        MOVE.W  $112,A2
        JSR     (A2)    ;Get integer parameter
        MOVE.L  (A7)+,A5
        MOVE.W  14(A6,A1.L),D7  ;Y2
        MOVE.W  12(A6,A1.L),D6  ;X2
        MOVE.W  10(A6,A1.L),D5  ;Y1
        MOVE.W  8(A6,A1.L),D4   ;X1
        MOVE.W  6(A6,A1.L),D3   ;Colour
        MOVE.W  4(A6,A1.L),4(A5)        ;period 3
        MOVE.W  2(A6,A1.L),2(A5)        ;period 2
        MOVE.W  0(A6,A1.L),(A5)         ;period 1
        BSR.S   DODOT
        MOVE.L  A5,A0
        MOVEQ   #$19,D0 ; MT.RECHP
        TRAP    #1      ; release common heap
        MOVEQ   #0,D0
        RTS
;Draw line from X=D4,Y=D5 to X=D6,Y=D7 with colour D3
;and make dots with periods as pointed by A5 (0,2,4)
DODOT:  MOVEM.L D0-D7/A0-A4,-(A7)
        BSR     ANDD3
        MOVE.W  (A5),6(A5)      ;Workstore for period 1
        MOVE.W  2(A5),8(A5)     ;work per2
        MOVE.W  4(A5),10(A5)    ;work per3
        MOVE.W  #0,12(A5)       ;Actual mode=0
        AND.L   #$1FF,D6
        AND.L   #$1FF,D4
        AND.L   #$FF,D7
        AND.L   #$FF,D5
        MOVEQ   #1,D0           ;X Increment
        MOVEQ   #1,D1           ;Y Increment
        MOVE.L  D6,D2
        SUB.L   D4,D2           ;A0=X2-X1
        BCC.S   DRIGHT
        NEG.L   D2              ;A0=ABS(X2-X1)
        SUBQ.W  #2,D0           ;X Decrement
DRIGHT: MOVE.L  D2,A0
        MOVE.L  D7,D2
        SUB.L   D5,D2           ;A1=Y2-Y1
        BCC.S   DDOWN
        NEG.L   D2              ;A1=ABS(Y2-Y1)
        SUBQ.W  #2,D1           ;Y Decrement
DDOWN:  MOVE.L  D2,A1
        MOVE.L  A0,A2           ;Counter X
        MOVE.L  A1,A3           ;Counter Y
DLNLOP: MOVEM.W D0/D3/D4/D5,-(A7)
        MOVE.W  12(A5),D0       ;Actual mode
        CMP.W   #6,D0           ;Spaces after second period ?
        BNE.S   @0
        MOVE.W  #2,D0
@0:     CMP.W   #2,D0
        BEQ.S   NODOT
        LSL.L   #7,D5
        BSET    #17,D5
        MOVE.L  D5,A4
        MOVE.L  D4,D5
        LSR.W   #2,D5
        BCLR    #0,D5
        ADD.L   D5,A4
        MOVE.W  #$8080,D5
        AND.W   #$7,D4
        LSR.W   D4,D5
        AND.W   D5,D3
        NOT.W   D5
        AND.W   D5,(A4)
        OR.W    D3,(A4)
NODOT:  SUBQ.W  #1,6(A5,D0.W)
        BNE.S   GOON
        MOVE.W  0(A5,D0.W),6(A5,D0.W)
        ADDQ.W  #2,12(A5)
        CMP.W   #8,12(A5)       ;Go to mode 0 ?
        BNE.S   GOON
        MOVE.W  #0,12(A5)
GOON:   MOVEM.W (A7)+,D0/D3/D4/D5
        MOVE.W  D6,D2
        SUB.W   D4,D2           ;X2-X
        CMP.W   #-1,D2          ;-1 ?
        BEQ.S   DXEQX2
        LSR.W   #1,D2           ;1 or 0 ?
        BNE.S   DNXLIN
DXEQX2: MOVE.W  D7,D2
        SUB.W   D5,D2           ;Y2-Y
        CMP.W   #-1,D2          ;-1 ?
        BEQ.S   DYEQY2
        LSR.W   #1,D2           ;1 or 0 ?
        BEQ.S   DYEQY2
DNXLIN: MOVE.L  A2,D2
        SUB.L   A3,D2
        BCC.S   DXINC
        ADD.W   D1,D5
        ADD.L   A0,A2
        BRA     DLNLOP
DXINC:  ADD.W   D0,D4
        ADD.L   A1,A3
        BRA     DLNLOP
DYEQY2: MOVEM.L (A7)+,D0-D7/A0-A4
        RTS
        END