;                       LWC$ :   fonction SUPERBASIC convertissant les
;                                caractres majuscules en minuscules
;                       UPC$ :   fonction SUPERBASIC convertissant les
;                                caractres minuscules en majuscules

;                utilisation :   chane$ = LWC$(chane$)
;                                chane$ = UPC$(chane$)




bv_rip              equ       $58


                    move.w    bp_init,a0
                    lea       TABLE,a1
                    jsr       (a0)
                    rts

LWC                 moveq     #32,d7
                    moveq     #65,d4              Code du caractre "A"
                    moveq     #90,d5               "   "      "     "Z"
                    bra.s     SAISIE_PARAMETRE
UPC                 moveq     #-32,d7
                    moveq     #97,d4              Code du caractre "a"
                    moveq     #122,d5              "   "      "     "z"

SAISIE_PARAMETRE    move.w    ca_gtstr,a0
                    jsr       (a0)
                    bne.s     ERREUR_BP
                    subq.w    #1,d3               La fonction n'accepte
                    bne.s     ERREUR_BP           qu'un paramtre

                    move.l    a1,bv_rip(a6)       Rservation pour retour

                    move.w    0(a6,a1.l),d2       d2 = longueur chane
                    beq.s     SORTIE              Sortie si nulle
                    sub.w     #1,d2               Initialise compteur
                    add.l     #2,a1               a1 pointe premier car.

RECOMMENCE          move.b    0(a6,a1.l),d3       d3 = code caractre
                    cmp.b     d3,d4
                    bhi.s     CARACTERE_SUIVANT
                    cmp.b     d5,d3
                    bhi.s     CARACTERE_SUIVANT
                    add.b     d7,0(a6,a1.l)       Effectue la conversion
CARACTERE_SUIVANT   add.l     #1,a1
                    dbf       d2,RECOMMENCE

SORTIE              moveq     #1,d4               Type = chane
                    rts
ERREUR_BP           moveq     #err_bp,d0
                    rts

TABLE               dc.w      0,0,2
                    dc.w      LWC-*
                    dc.b      4,"LWC$"
                    dc.w      UPC-*
                    dc.b      4,"UPC$"
                    dc.w      0

                    END
