;                   MIN : fonction SUPERBASIC renvoyant le plus petit de
;                         deux nombres  virgule flottante
;                   MAX : fonction SUPERBASIC renvoyant le plus grand de
;                         deux nombres  virgule flottante

;                   utilisation : valeur_min = MIN(1.234,5.678)
;                                 valeur_max = MAX(1.234,5.678)


bv_rip              equ       $58


                    move.w    bp_init,a0
                    lea       TABLE,a1
                    jsr       (a0)
                    rts

MIN                 sf        d7                  Drapeau MIN
                    bra.s     SAISIE_PARAMETRES
MAX                 st        d7                  Drapeau MAX

SAISIE_PARAMETRES   move.w    ca_gtfp,a0
                    jsr       (a0)
                    bne.s     ERREUR_BP
                    sub.w     #2,d3               La fonction n'accepte
                    bne.s     ERREUR_BP           que deux paramtres

                    move.w    0(a6,a1.l),d1       Exposant du 1er  nombre
                    move.l    2(a6,a1.l),d2       Mantisse  "  "     "
                    smi       d5                  Drapeau 1er  nombre
                    move.w    6(a6,a1.l),d3       Exposant du 2me nombre
                    move.l    8(a6,a1.l),d4       Mantisse  "  "     "
                    smi       d6                  Drapeau 2me nombre

                    cmp.b     d5,d6               Les nombres sont-ils de
                    beq.s     MEME_SIGNE          signes diffrents ?

                    tst.b     d5                  1er  nombre ngatif ?
SELECTION           smi       d6
                    eor.b     d6,d7
                    bne.s     PLACE_RESULTAT      1er  nombre slectionn
                    move.w    d3,d1
                    move.l    d4,d2
                    bra.s     PLACE_RESULTAT      2me nombre slectionn

MEME_SIGNE          tst.b     d5                  Les nombres sont-ils
                    bmi.s     NEGATIFS            ngatifs ?
                    cmp.w     d3,d1               Nombres >= 0
TESTS               bne.s     SELECTION
                    cmp.l     d4,d2
                    bra.s     SELECTION

NEGATIFS            cmp.w     d1,d3               Nombres <  0
                    bra.s     TESTS

PLACE_RESULTAT      add.l     #6,a1
                    move.l    a1,bv_rip(a6)       Rservation pour retour
                    move.w    d1,0(a6,a1.l)       Place le rsultat
                    move.l    d2,2(a6,a1.l)
                    moveq     #2,d4               Type = flottant
                    rts
ERREUR_BP           moveq     #err_bp,d0
                    rts

TABLE               dc.w      0,0,2
                    dc.w      MIN-*
                    dc.b      3,"MIN"
                    dc.w      MAX-*
                    dc.b      3,"MAX"
                    dc.w      0

                    END
