BP.INIT     EQU      $110
BV.CHRIX    EQU      $11A
BV_RIP      EQU      $58
CA.GTFP     EQU      $114
RI.EXECB    EQU      $11E
RI.EXEC     EQU      $11C
RI.ADD      EQU      $0A
RI.SUB      EQU      $0C
RI.MULT     EQU      $0E
RI.DIV      EQU      $10
RI.DUP      EQU      $16
RI.POWFP    EQU      $30
RI.STORE    EQU      $01
*
            LEA      PROC_TAB,A1
            MOVE.W   BP.INIT,A2
            JSR      (A2)
            MOVEQ    #$0,D0
            RTS
*
PROC_TAB    DC.W     0
            DC.W     0
            DC.W     9
            DC.W     MT-*
            DC.B     2,'MT',0
            DC.W     VA-*
            DC.B     2,'VA',0
            DC.W     VFR-*
            DC.B     3,'VFR'
            DC.W     VAR-*
            DC.B     3,'VAR'
            DC.W     TCA-*
            DC.B     3,'TCA'
            DC.W     TNC-*
            DC.B     3,'TNC'
            DC.W     TEE-*
            DC.B     3,'TEE'
            DC.W     RAE-*
            DC.B     3,'RAE'
            DC.W     RAFE-*
            DC.B     4,'RAFE',0
            DC.W     0
*
MT          BSR      GET_PAR
            BNE      GET_RTS
            CMP.W    #2,D3
            BNE      ERR_BP
            BSR      INIT_RIP
            LEA      OP_TAB,A3
            BSR      EX_TAB
            BSR      EX_OP
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            BSR      RET_VAL
            RTS
*
VA          BSR      GET_PAR
            BNE      GET_RTS
            CMP.W    #2,D3
            BNE      ERR_BP
            BSR      INIT_RIP
            LEA      OP_TAB,A3
            BSR      EX_TAB
            LEA      OP_TAB4,A3
            BSR      EX_TAB
            BSR      EX_OP
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            BSR      RET_VAL
            RTS
*
VFR         BSR      GET_PAR
            BNE      GET_RTS
            CMP.W    #2,D3
            BNE      ERR_BP
            BSR      INIT_RIP
            LEA      OP_TAB,A3
            BSR      EX_TAB
            LEA      OP_TAB1,A3
            BSR      EX_TAB
            LEA      OP_TAB2,A3
            BSR      EX_TAB
            BSR      EX_OP
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            BSR      RET_VAL
            RTS
*
VAR         BSR      GET_PAR
            BNE      GET_RTS
            CMP.W    #2,D3
            BNE      ERR_BP
            BSR      INIT_RIP
            LEA      OP_TAB,A3
            BSR      EX_TAB
            LEA      OP_TAB1,A3
            BSR      EX_TAB
            LEA      OP_TAB3,A3
            BSR      EX_TAB
            BSR      EX_OP
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            BSR      RET_VAL
            RTS
*
TCA         BSR      GET_PAR
            BNE      GET_RTS
            CMP.W    2,D3
            BNE      ERR_BP
            BSR      INIT_RIP
            LEA      OP_TAB,A3
            BSR      EX_TAB
            LEA      OP_TAB1,A3
            BSR      EX_TAB
            LEA      OP_TAB3,A3
            BSR      EX_TAB
            LEA      OP_TAB5,A3
            BSR      EX_TAB
            BSR      EX_OP
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            BSR      RET_VAL
            RTS
*
TNC         BSR      GET_PAR
            BNE      GET_RTS
            CMP.W    #2,D3
            BNE      ERR_BP
            BSR      INIT_RIP
            LEA      OP_TAB6,A3
            BSR      EX_TAB
            BSR      EX_OP
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            BSR      RET_VAL
            RTS
*
TEE         BSR      GET_PAR
            BNE      GET_RTS
            CMP.W    #2,D3
            BNE      ERR_BP
            BSR      INIT_RIP
            LEA      OP_TAB7,A3
            BSR      EX_TAB
            BSR      EX_OP
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            BSR      RET_VAL
            RTS
*
RAE         BSR      GET_PAR
            BNE      GET_RTS
            CMP.W    #2,D3
            BSR      INIT_RIP
            LEA      OP_TAB6,A3
            BSR      EX_TAB
            LEA      OP_TAB9,A3
            BSR      EX_TAB
            BSR      EX_OP
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            BSR      RET_VAL
            RTS
*
RAFE        BSR      GET_PAR
            BNE      GET_RTS
            CMP.W    #2,D3
            BNE      ERR_BP
            BSR      INIT_RIP
            LEA      OP_TAB6,A3
            BSR      EX_TAB
            LEA      OP_TAB8,A3
            BSR      EX_TAB
            BSR      EX_OP
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            ADDQ.W   #6,A1
            BSR      RET_VAL
            RTS
*
GET_PAR     MOVE.W   CA.GTFP,A2
            JSR      (A2)
            RTS
*
INIT_RIP   MOVE.L   A1,BV_RIP(A6)
            MOVEQ    #60,D1
            MOVE.W   BV.CHRIX,A2
            JSR      (A2)
            MOVE.L   BV_RIP(A6),A1
            LEA      12(A1),A4
            MOVE.W   #$00,-2(A6,A1.L)
            MOVE.L   #$08014000,-6(A6,A1.L)
            SUBQ.W   #6,A1
            RTS
*
EX_TAB      MOVE.W   RI.EXECB,A2
            JSR      (A2)
            RTS
*
EX_OP       MOVE.W   #-5,D0
            MOVE.W   RI.EXEC,A2
            JSR      (A2)
            RTS
*
RET_VAL     MOVE.L   A1,BV_RIP(A6)
            MOVEQ    #2,D4
            RTS
*
GET_RTS     RTS
*
ERR_BP      MOVE.W   -15,D0
            RTS
*
RIS_PAR2    EQU      250
RIS_PAR1    EQU      244
RIS_CONS    EQU      238
RIS_VAL1    EQU      232
RIS_VAL2    EQU      226
*
OP_TAB      DC.B     RIS_PAR1
            DC.B     RIS_CONS
            DC.B     RI.ADD
            DC.B     RIS_PAR2
            DC.B     RI.POWFP
            DC.B     0
*
OP_TAB1     DC.B     RI.DUP
            DC.B     RIS_CONS
            DC.B     RI.SUB
            DC.B     0
*
OP_TAB2     DC.B     RIS_VAL2
            DC.B     RIS_PAR1
            DC.B     RI.DIV
            DC.B     0
*
OP_TAB3     DC.B     RIS_VAL1
            DC.B     RIS_PAR1
            DC.B     RI.MULT
            DC.B     RI.DIV
            DC.B     0,0
*
OP_TAB4     DC.B     RIS_CONS
            DC.B     RIS_VAL1
            DC.B     RI.DIV
            DC.B     0
*
OP_TAB5     DC.B     RIS_CONS
            DC.B     RIS_VAL2
            DC.B     RI.DIV
            DC.B     0
*
OP_TAB6     DC.B     RIS_CONS
            DC.B     RIS_PAR2
            DC.B     RI.DIV
            DC.B     RIS_PAR1
            DC.B     RIS_CONS
            DC.B     RI.ADD
            DC.B     RIS_VAL1
            DC.B     RI.POWFP
            DC.B     RIS_CONS
            DC.B     RI.SUB
            DC.B     RIS_PAR2
            DC.B     RI.MULT
            DC.B     0,0
*
OP_TAB7     DC.B     RIS_PAR1
            DC.B     RIS_PAR2
            DC.B     RI.DIV
            DC.B     RIS_CONS
            DC.B     RI.ADD
            DC.B     RIS_PAR2
            DC.B     RI.POWFP
            DC.B     RIS_CONS
            DC.B     RI.SUB
            DC.B     0
*
OP_TAB8     DC.B     RIS_PAR1
            DC.B     RIS_VAL2
            DC.B     RI.DIV
            DC.B     0
*
OP_TAB9     DC.B     RIS_VAL2
            DC.B     RIS_PAR1
            DC.B     RI.DIV
            DC.B     0
*
            END







