*         TITLE SUPRESSION DE L'INDICATEUR DE JOB D'UN FICHIER
*         NOLIST
*
* Nouvelle commande SuperBASIC supprimant l'indicateur de job dans l'en-tte
* de fichier (pour les fichiers _RSP produits par certains assembleurs)
*
* La syntaxe est UNJOB fdk1_nom_de_fichier
*
* Par C.TRONCHE (87124)
*
* Logithque QLCF
*
* Commenc le 20/3/88
*    v1.00 du 20/3/88
*
*    v1.01 25/2/98 - amended by Rich Mellor to work on SMSQ/E & Minerva


INFINITE EQU -1    Temporisation infinie

         LEA DEFPROC,A1
         MOVEA $110,A0
         JSR (A0)
         CLR D0
         RTS
DEFPROC  DC.W 1
         DC.W UNJOB-*
         DC.B 5,'UNJOB'
         DC.W 0,0,0
BADPAR   MOVEQ #-15,D0
         RTS
OUVFIC   MOVE.B 1(A6,A3.L),D1
         AND.B #$F,D1
         CMP.B #1,D1
         BNE.S PLNOVA
         LEA 8(A3),A5
         MOVEA $116,A2
         JSR (A2)
         SUBQ #1,D3
         BNE.S BPOUFI
         BRA.S OUVFI2
BPOUFI   MOVEQ #-15,D0
ERROFI   RTS
PLNOVA   SUBQ.B #2,D1
         BNE.S BPOUFI
         MOVE 2(A6,A3.L),D0
         LSL #3,D0
         MOVEA.L $18(A6),A0
         ADDA D0,A0
         MOVE 2(A6,A0.L),D0
         MOVEA.L $20(A6),A0
         ADDA D0,A0
         LEA 0(A6,A0.L),A0
         MOVE.B (A0)+,D1
         BEQ.S BPOUFI
         CMP.B #32,D1
         BHI.S BPOUFI
         EXT D1
         MOVE D1,D4
         ADDQ #3,D1
         BCLR #0,D1
         EXT D1
         EXT.L D1
         MOVEA $11A,A1
         JSR (A1)
         CMP.B #$FD,D0
         BEQ.S ERROFI
         MOVEA.L $58(A6),A1
         LEA 0(A6,A1.L),A2
         MOVE D4,(A2)+
         SUBQ #1,D4
TRAFIL   MOVE.B (A0)+,(A2)+
         DBRA D4,TRAFIL
OUVFI2   LEA 0(A6,A1.L),A0
         MOVEQ #-1,D1
         MOVEQ #0,D3         - Fixed in v1.01 (previously MOVE.L D5,D3)
         MOVEQ #1,D0
         TRAP #2
         RTS
UNJOB    MOVE.L A5,D0        Pointeur de fin de paramtres
         SUB.L A3,D0           -pointeur de dbut
         SUBQ #8,D0          1 paramtre ?
         BNE BADPAR            non -> "Bad parameter"
         BSR OUVFIC          Ouverture de fichier
         TST D0              Problme?
         BEQ.S OKOUV1          ->non,continue
RETOUR   RTS                   Sinon retour

RET001   ADDA #14,SP         Libre la pile
         MOVE.L D0,-(SP)     Empile l'erreur
         MOVEQ #2,D0
         TRAP #2
         MOVE.L (SP)+,D0     Rcupre l'erreur
         RTS

OKOUV1   SUBA #14,SP         Rserve 14 octets pour l'en-tte
         MOVEQ #14,D2
         MOVEQ #INFINITE,D3
         MOVEA.L SP,A1
         MOVEQ #$47,D0
         TRAP #3             Lecture de l'en-tte
         TST D0              Problme
         BNE.S RET001          Oui->retour
         CLR 4(SP)           Drapeau  0
         MOVEQ #INFINITE,D3
         MOVEA.L SP,A1
         MOVEQ #$46,D0
         TRAP #3
         BRA.S RET001

         END
