* wld levenshtein abstand zweier strings
*
flag	equ	0
p	equ	2
q	equ	4
r	equ	6
feld	equ	8

	lea	defs,a1
	move.w	$110,a0
	jmp	(a0)

defs:	dc.w	0,0,3
	dc.w	wld-*
	dc.b	3,'WLD'
	dc.w	soundex-*
	dc.b	7,'SOUNDEX'
	dc.w	phonem-*
	dc.b	6,'PHONEM',0
	dc.w	0

wld:	move.l	a5,d7		;ende parameterstack
	sub.l	a3,d7		;anfang parameterstack
	lsr.l	#3,d7		;anzahl der parameter
	cmp.w	#2,d7		;nur zwei strings
	beq.s	wld1
	cmp.w	#3,d7		;zwei strings + gross/klein
	beq.s	wld1
	cmp.w	#5,d7		;zwei strings + 3 bewertungskonstanten
	beq.s	wld1
	cmp.w	#6,d7		;zwei strings + 3 konstanten + klein/gross
	beq.s	wld1
err_bp:	moveq	#-15,d0		;falsche parametanzahl
        rts
*parameter holen
wld1:   move.l	a5,-(sp)
	lea	16(a3),a5
	move.w	$116,a0		;strings holen
	jsr	(a0)
	move.l	a5,a3
	move.l	(sp)+,a5
	tst.w	d0
	bne.s	err_bp
	cmp.w	#2,d7		;nur zwei parameter ?
	beq.s   start
	move.w	$112,a0		;integer holen
	jsr	(a0)
	tst.w	d0
	bne.s	err_bp
start:	trap	#0		;supervisormode
	lea	0(a6,a1.l),a5	;integer
	move.l	a5,a3		;1.string
	move.l	d7,d0
	subq.l	#2,d0
	lsl.l	#1,d0
	add.l	d0,a3
	move.w	(a3),d0		;laenge 1. string
	lea	2(a3,d0.w),a4
	move.l	a4,d0
	addq.l	#1,d0
	bclr	#0,d0
	move.l	d0,a4		;2.string
	move.w	(a3),d1
	addq.w	#1,d1
	move.w	(a4),d2
	addq.w	#1,d2
	mulu	d2,d1
	lsl.l	#2,d1
	movem.l	a3-a5/d7,-(sp)
	moveq	#$18,d0
	addq.l	#8,d1
	moveq	#-1,d2
	trap	#1		;speicher reservieren
	movem.l	(sp)+,a3-a5/d7
        tst.w	d0
	bne	exit
*parameter initialisieren
        clr.w	flag(a0)
	move.w	#1,p(a0)
	move.w	#1,q(a0)
	move.w	#1,r(a0)
*2 parameter sind schon bestimmt
	cmp.w	#2,d7
	beq.s	wld2
	cmp.w	#3,d7
	bne.s	para5
*nur flag
	not.w	flag(a0)
	bra.s	wld2
para5:	move.w	(a5)+,p(a0)
	move.w	(a5)+,q(a0)
	move.w	(a5)+,r(a0)
	cmp.w	#6,d7
	bne.s	wld2
	not.w	flag(a0)
wld2:	move.l	a0,a5
*feld innitialisieren
	move.w	q(a5),d1
	move.w	r(a5),d2
	move.w	(a3),d6		;laenge 1
	moveq	#0,d0
	subq.w	#1,d6
	bmi	ende
	move.w	(a4),d7		;laenge 2
	moveq	#0,d0
	subq.w	#1,d7
	bmi	ende
	lea	feld(a5),a0
	clr.w	(a0)+		;feld(0,0)=0
	move.w	d6,d0
loop1:	move.w	d1,(a0)+	;feld(0,i)=i*q
	add.w	q(a5),d1
	dbra	d0,loop1
loop2:	move.w	d2,(a0)+	;feld(j,0)=j*r
	move.w	d6,d0
loop3:	clr.w	(a0)+
	dbra	d0,loop3
	add.w	r(a5),d2
	dbra	d7,loop2
	lea	feld(a5),a2
	move.w	(a3)+,d6	;laenge 1
	move.w	d6,d4
        lsl.w	#1,d4
	subq.w	#1,d6
	move.w	(a4)+,d7	;laenge 2
	move.w	d7,d5
	lsl.w	#1,d5
	subq.w	#1,d7
loop4:	move.w	d6,d3
	move.l	a3,a1
loop5:	move.w	p(a5),d0	;pp=p
	move.b	(a1)+,d1
	move.b	(a4),d2
	tst.w	flag(a5)
	beq.s	loop6
	cmp.b	#'a',d1
	blt.s	loop6a
	cmp.b	#'z',d1
	bhi.s	loop6a
	bclr	#5,d1
loop6a:	cmp.b	#'a',d2
	blt.s	loop6
	cmp.b	#'z',d2
	bhi.s	loop6
	bclr	#5,d2
loop6:	cmp.b	d1,d2
	bne.s	loop7
	moveq	#0,d0
loop7:	add.w	(a2),d0		;x=d(i-1,j-1)+pp
	move.w	2(a2,d4.w),d1	;y=d(i,j-1)
	add.w	q(a5),d1	;y=y+q
	move.w	2(a2),d2	;z=d(i-1,j)
	add.w	r(a5),d2	;z=z+r
	cmp.b	d0,d1		;x<y
	ble.s	loop8
	exg	d0,d1
loop8:	cmp.b	d1,d2		;y<z
	ble.s	loop9
	exg	d1,d2
loop9:	move.w	d2,4(a2,d4.w)	;d(i,j)=z
	addq.l	#2,a2
	dbra	d3,loop5
	addq.l	#2,a2
	addq.l	#1,a4
	dbra	d7,loop4
	move.w	0(a2,d4.w),d0	;feld(laenge1,laenge2)
ende:	move.l	$58(a6),a1
	subq.l	#2,a1
	move.l	a1,$58(a6)
	move.w	d0,0(a6,a1.l)
	moveq	#$19,d0
	move.l	a5,a0
	trap	#1
	moveq	#0,d0
	moveq	#3,d4
*keine parameter mehr
exit:	move.w	#0,sr		;in usermode
	rts

*einen string holen
getstr:	move.w	$116,a0		;get string
	jsr	(a0)
	tst.w	d0
	beq.s	getstr1
	addq.l	#4,sp
	rts
getstr1:cmp.w	#1,d3
	bne.s	egetstr
	rts
egetstr:moveq	#-15,d0
	addq.l	#4,sp
	rts

*string auf stack schieben
strrts:	move.l	$58(a6),a1
	move.w	(a5),d1
	addq.w	#3,d1
	bclr	#0,d1
	sub.w	d1,a1
	move.l	a1,$58(a6)
	lea	0(a6,a1.l),a0
	move.l	a5,a1
	addq.w	#1,d1
strrtsl:move.b	(a1)+,(a0)+
	dbra	d1,strrtsl
	rts

*einzelne bytes austauschen
change1:move.w	(a1),d7
	subq.w	#1,d7
	bmi.s	ec1
	lea	2(a1),a4
	move.l	a4,a0	
cloop1:	move.b	(a0)+,d1
	move.l	a2,a3
cloop2:	move.b	(a3)+,d2
	beq.s	ecl1
	cmp.b	d1,d2
	beq.s	ecl2
	addq.l	#1,a3
	bra.s	cloop2
ecl2:	move.b	(a3),(a4)+
	bra.s	ecl1a
ecl1:	move.b	d1,(a4)+
ecl1a:	addq.w	#1,(a1)
	dbra	d7,cloop1
ec1:	rts

*zweier kombinationen ersetzen
change2:move.w	(a1),d7
	subq.w	#1,d7
	bmi.s	ec2
	lea	2(a1),a4
	move.l	a4,a0
	clr.w	(a1)
cloop3:	move.b	(a4)+,d1		;1.zeichen
	bsr	find2
	beq.s	ecl3
	move.b	d1,(a0)+
	addq.w	#1,(a1)
	bra.s	ecl3b
ecl3:	tst.b	(a3)
	beq.s	ecl3a
	move.b	(a3),(a0)+
	addq.w	#1,(a1)
ecl3a:	move.b	1(a3),(a0)+
	addq.w	#1,(a1)
	addq.l	#1,a4
	subq.w	#1,d7
	bmi.s	ec2
ecl3b:	dbra	d7,cloop3
ec2:	rts

*zweierkombinationen finden
find2:	tst.w	d7
	beq.s	f2nf
	move.l	a2,a3
find2l:	move.b	(a3),d2
	beq.s	f2nf
	cmp.b	d1,d2
	beq.s	found1
	addq.l	#4,a3
	bra.s	find2l
found1:	move.b	1(a3),d2
	move.b	(a4),d0
	cmp.b	d0,d2
	beq.s	f2f
	addq.l	#4,a3
	bra.s	find2l
f2f:	addq.l	#2,a3
	moveq	#0,d0
	tst.w	d0
	rts
f2nf:	moveq	#-1,d0
	tst.w	d0
	rts

*nur zahlen in string lassen
onlyz:	move.w	(a1),d7
	beq.s	eo1
	subq.w	#1,d7
	move.l	a1,a2
	clr.w	(a1)+
	move.l	a1,a4
oloop1:	move.b	(a1)+,d1
	cmp.b	#'0',d1
	blt.s	eol1
	cmp.b	#'9',d1
	bhi.s	eol1
	move.b	d1,(a4)+
	addq.w	#1,(a2)
eol1:	dbra	d7,oloop1
eo1:	rts

*nur bestimmte buchstaben zulassen
onlyfew:move.w	(a1),d7
	beq.s	eof
        subq.l	#1,d7
	move.l	a1,a4
	clr.w	(a4)+
	move.l	a4,a3
ofloop:	move.b	(a4)+,d1
	move.l	a2,a0
ofl1:	move.b	(a0)+,d2
	beq.s	eofl1
	cmp.b	d1,d2
	bne.s	ofl1
	move.b	d1,(a3)+
	addq.w	#1,(a1)
eofl1:	dbra	d7,ofloop	
eof:	rts

*zeichenwiederholungen loeschen
only1:	move.w	(a1),d7
	subq.w	#2,d7
	bmi.s	eo2
	move.l	a1,a2
	clr.w	(a1)+
	move.l	a1,a4
	move.b	(a1)+,d1
	move.b	d1,(a4)+
	addq.w	#1,(a2)
oloop2:	move.b	(a1)+,d2
	cmp.b	d1,d2
	beq.s	eoloop2
	move.b	d2,(a4)+
	addq.w	#1,(a2)
	move.b	d2,d1
eoloop2:dbra	d7,oloop2
eo2:	rts

*in grossbuchstaben verwandeln
makebig:move.w	(a1)+,d7
	subq.w	#1,d7
	bmi.s	emb
mbloop:	bclr	#5,(a1)+
	dbra	d7,mbloop
emb:	rts

*deutsche sonderzeichen entfernen
ohned:	move.w	(a4)+,d7
	lea	2(a0),a1
	subq.w	#1,d7
	bmi.s	eod
odloop:	move.b	(a4)+,d1
	move.w	#'eu',d2
	cmp.b	#'',d1
	beq.s	eodl
	move.w	#'EU',d2
	cmp.b	#'',d1
	beq.s	eodl
	move.w	#'ea',d2
	cmp.b	#'',d1
	beq.s	eodl
	move.w	#'EA',d2
	cmp.b	#'',d1
	beq.s	eodl
	move.w	#'eo',d2
	cmp.b	#'',d1
	beq.s	eodl
	move.w	#'EO',d2
	cmp.b	#'',d1
	beq.s	eodl
	move.w	#'ss',d2
	cmp.b	#'',d1
	beq.s	eodl
        moveq	#0,d2
	move.b	d1,d2
eodl:	move.b	d2,(a1)+
	addq.w	#1,(a0)
	ror.w	#8,d2
	tst.b	d2
	beq.s	eodl1
	move.b	d2,(a1)+
	addq.w	#1,(a0)
eodl1:	dbra	d7,odloop
eod:	rts

*soundex routine
soundex:bsr	getstr
	trap	#0
	lea	0(a6,a1.l),a4	;string
	move.w	(a4),d1
	and.l	#$0000ffff,d1
	lsl.l	#2,d1
	moveq	#$18,d0
	moveq	#-1,d2
	trap	#1
	move.l	a0,a5
	tst.w	d0
	bne	esound
	move.l	a5,a0
	bsr	ohned		;keine deutschen sonderzeichen
	move.l	a5,a1
	bsr	makebig		;nur gross
	move.l	a5,a1		;freier speicher
	lea	tab1,a2		;zeichentabelle
	bsr	change1		;einfache zeichen ersetzen
	move.l	a5,a1
	bsr	onlyz		;nur zahlen
	move.l	a5,a1
	bsr	only1		;wiederholungen loeschen
	bsr	strrts
	moveq	#$19,d0
	move.l	a5,a0
	trap	#1
	moveq	#0,d0
	moveq	#1,d4
esound:	move.w	#0,sr
	rts	

*phonem routine
phonem:	bsr	getstr
	trap	#0
	lea	0(a6,a1.l),a4	;string
	move.w	(a4),d1
	and.l	#$0000ffff,d1
	lsl.l	#2,d1
	moveq	#$18,d0
	moveq	#-1,d2
	trap	#1
	move.l	a0,a5
	tst.w	d0
	bne	ephonem
	move.l	a5,a0
	bsr	ohned		;keine deutschen sonderzeichen
	move.l	a5,a1
	bsr	makebig		;nur gross
	move.l	a5,a1		;freier speicher
	lea	tab2,a2		;zeichentabelle fuer zweierkombination
	bsr	change2		;einfache zeichen ersetzen
	move.l	a5,a1		;freier speicher
	lea	tab3,a2		;zeichentabelle fuer einerkombination
	bsr	change1		;einfache zeichen ersetzen
	move.l	a5,a1
	lea	tab4,a2
	bsr	onlyfew
	move.l	a5,a1
	bsr	only1		;wiederholungen loeschen
	bsr	strrts
	moveq	#$19,d0
	move.l	a5,a0
	trap	#1
	moveq	#0,d0
	moveq	#1,d4
ephonem:move.w	#0,sr
	rts	

*tabelle fuer soundex
tab1:	dc.b	'B1'
	dc.b	'F1'
	dc.b	'P1'
	dc.b	'V1'
        dc.b	'H2'
        dc.b	'C2'
        dc.b	'G2'
        dc.b	'J2'
        dc.b	'K2'
        dc.b	'Q2'
        dc.b	'S2'
	dc.b	'X2'
	dc.b	'Z2'
	dc.b	'D3'
	dc.b	'T3'
	dc.b	'L4'
	dc.b	'M5'
	dc.b	'N5'
	dc.b	'R6'
	dc.b	0,0

*zweier tabelle fuer phonem
tab2:	dc.b	'SC',0,'C'
	dc.b	'SZ',0,'C'
	dc.b	'CZ',0,'C'
	dc.b	'TZ',0,'C'
	dc.b	'TS',0,'C'
	dc.b	'DS',0,'C'
	dc.b	'PH',0,'V'
	dc.b	'PF',0,'V'
	dc.b	'QUKV'
	dc.b	'UE',0,'Y'
	dc.b	'EUOY'
	dc.b	'AE',0,'E'
	dc.b	'OE',0,''
	dc.b	'KS',0,'X'
	dc.b	'EIAY'
	dc.b	'EYAY'
	dc.b	0,0

*einfache tabelle fuer phonem
tab3:   dc.b	'KC'
	dc.b	'GC'
	dc.b	'QC'
	dc.b	'IY'
	dc.b	'JY'
	dc.b	'FV'
	dc.b	'WV'
	dc.b	'PB'
	dc.b	'TD'
	dc.b	0,0

*erlaubte zeichen phonem
tab4:	dc.b	'ABCDKLMNORUVWXYZ'
	even
