xmin      equ       0
xmax      equ       2
ymin      equ       4
ymax      equ       6
screen    equ       8
xres      equ       12
yres      equ       14
colour    equ       16
xgross    equ       18
ygross    equ       20
winkel    equ       22
qlibm     equ       24

italic    equ       26
fett      equ       28
name      equ       30
puffer    equ       70
fonts     equ       90

          lea       defs,a1
          move.w    $110,a0
          jmp       (a0)

defs      dc.w      5
          dc.w      reso-*
          dc.b      7,'VG_RESO'
          dc.w      wind-*
          dc.b      7,'VG_WIND'
          dc.w      para-*
          dc.b      7,'VG_PARA'
          dc.w      load-*
          dc.b      7,'VG_LOAD'
          dc.w      print-*
          dc.b      8,'VG_PRINT',0
          dc.w      0,1
          dc.w      hoch-*
          dc.b      7,'VG_HOCH'
          dc.w      0

*Main routine for finding the base of the variables
getbase   movem.l   a3/a5,-(a7)
          moveq     #0,d0
          trap      #1
          move.l    $58(a0),a0
          lea       64(a0),a4
gbl       tst.b     (a4)
          bne.s     nobase
          cmp.l     #'RBVG',4(a4)
          bne.s     egbl
          move.l    12(a4),a4
          movem.l   (a7)+,a3/a5
          rts

egbl      addq.l    #8,a4
          bra.s     gbl

nobase    lea       64(a0),a4
gbl1      tst.b     (a4)
          bne.s     nobase1
          tst.l     4(a4)
          bne.s     egbl1
          tst.l     12(a4)
          beq.s     install
egbl1     addq.l    #8,a4
          bra.s     gbl1
nobase1   moveq     #-19,d0
          lea       12(a7),a7
          rts
nobase2 lea         12(a7),a7
          rts

install   moveq     #$18,d0
          moveq     #0,d1
          move.w    #256,d1
          moveq     #-1,d2
          trap      #1
          tst.w     d0
          bne.s     nobase2
          move.l    #'RBVG',4(a4)
          move.l    a0,12(a4)
          move.l    a0,a4
          clr.w     xmin(a4)
          move.w    #511,xmax(a4)
          clr.w     ymin(a4)
          move.w    #255,ymax(a4)
          move.l    #$20000,screen(a4)            Presume screen base $20000
          move.w    #512,xres(a4)                 Presume x resolution 512
          move.w    256,yres(a4)                  Presume y resolution 256
          move.w    #$FFFF,colour(a4)
          move.w    #8,xgross(a4)
          move.w    #8,ygross(a4)
          clr.w     winkel(a4)
          clr.w     italic(a4)
          clr.w     fett(a4)
          clr.w     qlibm(a4)
          lea       fonts(a4),a0
          moveq     #15,d0
instl     clr.l     (a0)+
          dbra      d0,instl
          movem.l   (a7)+,a3/a5
          rts

*hoehe eines fontsatzes bestimmen
hoch      bsr       getbase
          move.w    $112,a0
          jsr       (a0)
          tst.w     d0
          bne.s     ehoch
          cmp.w     #1,d3
          bne.s     ehoch
          move.w    0(a6,a1.l),d7                 *font number
          and.w     #15,d7
          lsl.w     #2,d7
          move.l    fonts(a4,d7.w),d0   *zeiger auf fontsatz
          bne.s     hoch1
          move.l    $58(a6),a1
          clr.w     0(a6,a1.l)
          bra.s     ehoch1
hoch1     move.l    d0,a0
          moveq     #0,d0
          moveq     #0,d1
          move.b    136(a0),d0
          move.b    138(a0),d1
          neg.b     d1
          add.w     d0,d1
          mulu      ygross(a4),d1
          asr.l     #3,d1
          move.l    $58(a6),a1
          move.w    d1,0(a6,a1.l)
ehoch1    moveq     #0,d0
          moveq     #3,d4
ehoch     rts
          
*load fonts
*parameters:
*1. font number
*2. filename
load      bsr       getbase
          move.l    a5,-(a7)
          lea       8(a3),a5
          move.w    $112,a0
          jsr       (a0)
          tst.w     d0
          bne       eload
          cmp.w     #1,d3
          bne       eload
          lea       fonts(a4),a0
          move.w    0(a6,a1.l),d7                 *font number
          and.w     #15,d7
          lsl.w     #2,d7
          lea       0(a0,d7.w),a0
          move.l    (a0),d0
          beq.s     loadok
          clr.l     (a0)
          move.l    a0,-(a7)
          move.l    d0,a0
          moveq     #$19,d0
          trap      #1
          move.l    (a7)+,a0
loadok  move.l      a0,-(a7)
          move.l    4(a7),a5
          lea       -8(a5),a3
          move.w    $116,a0
          jsr       (a0)
          move.l    (a7)+,a5
          tst.w     d0
          bne.s     eload
          moveq     #-15,d0
          cmp.w     #1,d3
          bne.s     eload
          lea       name(a4),a0
          move.w    0(a6,a1.l),d0
          addq.w    #1,d0
lloop     move.b    0(a6,a1.l),(a0)+
          addq.l    #1,a1
          dbra      d0,lloop
          moveq     #1,d0
          moveq   #-1,d1
          moveq     #0,d3
          lea       name(a4),a0
          trap      #2
          tst.w     d0
          bne.s     eload
          moveq     #$47,d0
          move.w    #14,d2
          moveq     #-1,d3
          lea       puffer(a4),a1
          trap      #3
          tst.w     d0
          bne.s     eload1
          moveq     #$18,d0
          move.l    puffer(a4),d1
          moveq     #-1,d2
          move.l    a0,-(a7)
          trap      #1
          move.l    a0,a1
          move.l    (a7)+,a0
          tst.w     d0
          bne.s     eload1
          move.l    a1,(a5)
          moveq     #$48,d0
          move.l    puffer(a4),d2
          moveq     #-1,d3
          trap      #3
          move.l    (a5),a1
          cmp.w     #'PK',(a1)
          beq.s     eload1
          clr.l     (a4)
          moveq     #$19,d0
          move.l    a1,a0
          trap      #1
          moveq     #2,d0
          trap      #2
          moveq     #-15,d0
          rts
eload1    moveq     #2,d0
          trap      #2
eload     addq.l    #4,a7
          rts

*fenster fuer textausgabe
*parameter
*1. xmin
*2. xmax
*3. ymin
*4. ymax
wind      bsr       getbase
          move.w    $112,a0
          jsr       (a0)
          tst.w     d0
          bne.s     ewind
          moveq     #-15,d0
          cmp.w     #4,d3
          bne.s     ewind
          move.w    0(a6,a1.l),xmin(a4) *xmin
          move.w    2(a6,a1.l),xmax(a4) *xmax
          move.w    4(a6,a1.l),ymin(a4) *ymin
          move.w    6(a6,a1.l),ymax(a4) *ymax
          moveq     #0,d0
ewind     rts

*aufloesung des grafikbildschirms eingeben
*parameter
*1. screenadresse
*2. xresolution in worten
*3. yresolution
reso      bsr       getbase
          move.w    $118,a0
          jsr       (a0)
          tst.w     d0
          bne.s     ereso
          moveq     #-15,d0
          cmp.w     #3,d3
          bne.s     ereso
          move.l    0(a6,a1.l),screen(a4)         *screenadresse
          move.w    6(a6,a1.l),d0                 *xreso in worten
          lsl.l     #3,d0
          move.w    d0,xres(a4)
          clr.w     xmin(a4)
          subq.w    #1,d0
          move.w    d0,xmax(a4)
          move.w    10(a6,a1.l),d0                *yreso
          move.w    d0,yres(a4)
          clr.w     ymin(a4)
          subq.w    #1,d0
          move.w    d0,ymax(a4)
          moveq     #0,d0
ereso     rts
          
*parameter fuer textausgabe
*parameter
*1. farbe 0..7
*2. x-vergroesserung
*3. y-vergroesserung
*4. winkel
*5. uebersetzung
*6. italic
*7. fett
para      bsr       getbase
          move.w    $112,a0
          jsr       (a0)
          tst.w     d0
          bne.s     epara
          moveq     #-15,d0
          cmp.w     #7,d3
          bne.s     epara
          move.w    0(a6,a1.l),d0                 *farbe
          and.w     #7,d0
          lsl.w     #1,d0
          lea       farbe,a2
          move.w    0(a2,d0.w),colour(a4)
          move.w    2(a6,a1.l),d0                 *x-groesse
          and.w     #127,d0
          move.w    d0,xgross(a4)
          move.w    4(a6,a1.l),d0                 *y-groesse
          and.w     #127,d0
          move.w    d0,ygross(a4)
          move.w    6(a6,a1.l),d0                 *winkel
paral   sub.w       #360,d0                       *nur von 0-359
          bpl.s     paral
          add.w     #360,d0
          move.w    d0,winkel(a4)
          move.w    8(a6,a1.l),qlibm(a4)
          move.w    10(a6,a1.l),italic(a4)
          move.w    12(a6,a1.l),fett(a4)
          moveq     #0,d0
epara     rts

*print einer fontkette
*parameter
*1. x-koordinate
*2. y-koordinate
*3. font number
*4. string
print     bsr       getbase
          move.l    a5,d0
          sub.l     a3,d0
          lsr.l     #3,d0
          cmp.w     #4,d0
          bne     eprint
          move.l    a5,-(sp)
          lea       24(a3),a5
          move.w    $112,a0
          jsr       (a0)
          tst.w     d0
          bne       exit
          moveq     #-15,d0
          cmp.w     #3,d3
          bne       exit
          move.l    (sp),a5
          lea       -8(a5),a3
          move.w    $116,a0
          jsr       (a0)
          tst.w     d0
          bne       exit
          moveq     #-1,d0
        cmp.w       #1,d3
          bne.s     eprint
          move.w    0(a6,a1.l),d0                 *length of string
          addq.w    #1,d0
          bclr      #0,d0
          lea       2(a1,d0.w),a2
          move.w    0(a6,a2.l),d0                 *x-coordinate
          move.w    2(a6,a2.l),d1                 *y-coordinate
          move.w    4(a6,a2.l),d7                 *font number
          and.w     #15,d7
          lsl.w     #2,d7
          move.l    fonts(a4,d7.w),a0
          lea       128(a0),a0
          move.w    0(a6,a1.l),d7                 *font offset
          subq.w    #1,d7
          bmi.s   pok
ploop     movem.w   d0/d1,puffer(a4)
          move.w    fett(a4),d6
          move.b    2(a6,a1.l),d2                 *font holen
ploop1    movem.w   puffer(a4),d0/d1
          add.w     d6,d0
          sub.w     d6,d1
          movem.l   d2/d6/d7/a0/a1/a4/a6,-(sp)
          bsr       bgip
          movem.l   (sp)+,d2/d6/d7/a0/a1/a4/a6
          movem.w   d0/d1,puffer+4(a4)
          dbra    d6,ploop1
          movem.w   puffer+4(a4),d0/d1
eploop    addq.l    #1,a1
          dbra      d7,ploop
pok       moveq     #0,d0
exit      addq.l    #4,sp
eprint    rts

*ein BGI font drucken
*d0 enthaelt x-koordinate
*d1 enthaelt y-koorninate
*d2 enthaelt font
*a0 zeiger auf bgi-fontsatz
*nach Rueckkehr ist d0,d1 korigiert
bgip      and.w     #$00ff,d2
*ql-font austauschen
          tst.w     qlibm(a4)
          beq.s     bgip1
          lea       tabelle,a1
          move.b    0(a1,d2.w),d2
bgip1   moveq       #0,d3
          move.b    4(a0),d3
          sub.w   d3,d2                 *ist es druckbar ?
          bmi       ebgip               *nein
          moveq     #0,d3
          move.b    1(a0),d3
          sub.w     d2,d3               *ist es druckbar
          bmi       ebgip               *nein
          moveq     #0,d7
          move.b    1(a0),d7  *anzahl der font
          move.w    d7,d6
          lsl.w     #1,d7               *2*anzahl der font
          movem.l   d0/d1/d2/d7/a0,-(a7)
          add.w     d7,d6               *3*anzahl der font
          lea       16(a0,d6.w),a1      *vektortabelle
          lsl.w     #1,d2
          move.b    17(a0,d2.w),d5      *offset fuer vektoren
          lsl.w     #8,d5
          move.b    16(a0,d2.w),d5      *wegen IBM so umstaendlich
          lea       0(a1,d5.w),a0       *zeiger auf vektoren
          movem.w   d0/d1,-(a7)
bgipl1    move.b    (a0)+,d6  *x-relativ
          move.b    (a0)+,d7  *y-relativ
          move.b    d6,d4
          and.b     #$80,d4
          lsr.b     #6,d4
          move.b    d7,d5
          and.b     #$80,d5
          lsr.b     #7,d5
          add.b     d5,d4               *funktionscode fuer vektor
          beq       ebgipl1             *ende der vektordefinition
*neuen koordinaten berechnen und skalieren
          and.b     #$7f,d6             *nur relevante informationen
          lsl.b     #1,d6
          asr.b     #1,d6
          ext.w     d6                  *auf wort erweitern
          muls      xgross(a4),d6       *skalieren
          and.b     #$7f,d7             *nur relevante informationen
          lsl.b     #1,d7
          asr.b     #1,d7
          ext.w     d7                  *auf wort erweitern
          muls      ygross(a4),d7       *skalieren
          asr.w     #3,d6
          asr.w     #3,d7
          move.w    winkel(a4),d5       *richtung
          cmp.b     #1,d4               *z.z. dummy
          beq.s     bgipl1
          cmp.b     #2,d4               *moveto
          bne.s     draw                *zeichnen
*nur move
move      movem.w   (a7),d0/d1
          cmp.w     #0,d5               *0 grad
          bne.s     move1
        add.w       d6,d0               *neue x-koordinate
          sub.w     d7,d1               *neue y-koordinate
          bra.s     emove
move1     cmp.w     #90,d5          *90 grad
          bne.s     move2
          add.w     d7,d0               *neue x-koordinate
          add.w     d6,d1               *neue y-koordinate
          bra.s     emove
move2     cmp.w     #180,d5         *180 grad
          bne.s     move3
          sub.w     d6,d0               *neue x-koordinate
          add.w     d7,d1               *neue y-koordinate
          bra.s     emove
move3     cmp.w     #270,d5         *270 grad
          bne.s     move4
          sub.w     d7,d0               *neue x-koordinate
          sub.w     d6,d1               *neue y-koordinate
        bra.s       emove
move4   lea     sin,a1          ;Wert aus Tabelle holen
        lsl.w   #2,d5
        move.w  0(a1,d5.w),d2   ;sin holen
        move.w  2(a1,d5.w),d3   ;cos holen
        moveq   #14,d4
          movem.w   d6/d7,-(a7)
          muls      d3,d6
          muls      d2,d7
          add.l     d6,d7
          asr.l     d4,d7
          add.w     d7,d0
          movem.w   (a7),d6/d7
          muls      d2,d6
          muls      d3,d7
          sub.l     d7,d6
          asr.l     d4,d6
          add.w     d6,d1
          movem.w   (a7)+,d6/d7
emove     tst.w     italic(a4)
          beq       bgipl1
          divs      italic(a4),d7
          add.w     d7,d0
          bra       bgipl1
*linie zeichnen
draw      movem.w   (a7),d2/d3
          cmp.w     #0,d5               *0 grad
          bne.s     draw1
          add.w     d6,d2               *ende x-koordinate
          sub.w     d7,d3               *ende y-koordinate
          bra.s     edraw
draw1     cmp.w     #90,d5              *90 grad
          bne.s     draw2
          add.w     d7,d2               *ende x-koordinate
          add.w     d6,d3               *ende y-koordinate
          bra.s     edraw
draw2     cmp.w     #180,d5             *180 grad
          bne.s     draw3
          sub.w     d6,d2               *ende x-koordinate
          add.w     d7,d3               *ende y-koordinate
          bra.s     edraw
draw3     cmp.w     #270,d5             *270 grad
          bne.s     draw4
          sub.w     d7,d2               *ende x-koordinate
          sub.w     d6,d3               *ende y-koordinate
          bra.s     edraw
draw4   lea     sin,a1          ;Wert aus Tabelle holen
        lsl.w   #2,d5
          movem.w   d0/d1,-(a7)
          movem.w   d6/d7,-(a7)
        move.w  0(a1,d5.w),d0   ;sin holen
        move.w  2(a1,d5.w),d1   ;cos holen
        moveq   #14,d4
          muls      d1,d6
          muls      d0,d7
          add.l     d6,d7
          asr.l     d4,d7
          add.w     d7,d2
          movem.w   (a7),d6/d7
          muls      d0,d6
          muls      d1,d7
          sub.l     d7,d6
          asr.l     d4,d6
          add.w     d6,d3
          movem.w   (a7)+,d6/d7
        movem.w     (a7)+,d0/d1
edraw     tst.w     italic(a4)
          beq.s     edraw1
          divs      italic(a4),d7
          add.w     d7,d2
edraw1    bsr       line                *linie ziehen
          bra       bgipl1
ebgipl1 addq.l      #4,a7
          movem.l   (a7)+,d0/d1/d2/d7/a0
          add.w     d2,d7
          moveq     #0,d5
          move.b    16(a0,d7.w),d5      *breite des fonts holen
          muls      xgross(a4),d5       *skalierung
          asr.l     #3,d5
          move.w    winkel(a4),d4
          cmp.w     #0,d4               *0 grad
          bne.s     ende1
          add.w     d5,d0
          rts
ende1     cmp.w     #90,d4              *90 grad
          bne.s     ende2
          add.w     d5,d1
          rts
ende2     cmp.w     #180,d4             *180 grad
          bne.s     ende3
          sub.w     d5,d0
          rts
ende3     cmp.w     #270,d4             *270 grad
          bne.s     ende4
          sub.w     d5,d1
          rts
ende4   lea     sin,a1          ;Wert aus Tabelle holen
        lsl.w   #2,d4
        move.w  0(a1,d4.w),d2   ;sin holen
        move.w  2(a1,d4.w),d3   ;cos holen
        moveq   #14,d4
          move.w    d5,d6
          muls      d3,d6
          asr.l     d4,d6
          add.w     d6,d0
          move.w    d5,d6
          muls      d2,d6
          asr.l     d4,d6
          add.w     d6,d1
ebgip     rts

*lineroutine mit clipping 
line    movem.l d2-d3/a0,-(a7)
        cmp.w   d0,d2
        bge.s   weiter1
        exg     d0,d2
        exg     d1,d3
weiter1 move.w  xmin(a4),d4
        move.w  xmax(a4),d5
        move.w  ymin(a4),d6
        move.w  ymax(a4),d7
        cmp.w   d4,d0                   *x1<xmin
        bpl     c1                      *nein
        cmp.w   d4,d2                   *x2<xmin
        bmi     eline
        movem.l d2-d3,-(a7)
        sub.w   d0,d2                   *delta x
        sub.w   d1,d3                   *delta y
        sub.w   d4,d0                   *x1-xmin
        ext.l   d3
        lsl.l   #8,d3                   *256*delta y
        divs    d2,d3                   *256*delta y / delta x
        muls    d0,d3                   *x1*256*delta y / delta x
        lsr.l   #8,d3                   *x1*delta y / delta x
        sub.w   d3,d1                   *y1-x1*delta y / delta x
        move.w  d4,d0                   *x1=xmin
        movem.l (a7)+,d2-d3
c1      cmp.w   d5,d0                   *x1>xmax
        bpl     eline                   *ja
        cmp.w   d5,d2                   *x2>xmax
        bmi     c2                      *nein
        movem.l d0-d1,-(a7)
        neg.w   d0
        neg.w   d1
        add.w   d2,d0                   *delta x
        add.w   d3,d1                   *delta y
        ext.l   d1
        lsl.l   #8,d1                   *256*delta y
        sub.w   d5,d2                   *xmax-x2
        neg.w   d2
        divs    d0,d1                   *256*delta y / delta x
        muls    d2,d1                   *( 400 - x2 )*256*delta y / delta x
        lsr.l   #8,d1                   *( 400 - x2 )*delta y /delta x
        add.w   d1,d3                   *y1+(400-x2)*delta y / delta x
        move.w  d5,d2                   *x2=xmax
        movem.l (a7)+,d0-d1
c2      cmp.w   d6,d1                   *y1<ymin
        bpl     c3                      *nein
        cmp.w   d6,d3                   *y2<ymin
        bmi     eline                   *ja
        movem.l d2-d3,-(a7)
        sub.w   d0,d2                   *delta x
        sub.w   d1,d3                   *delta y
        ext.l   d2
        sub.w   d6,d1                   *y1-ymin
        lsl.l   #8,d2                   *256*delta x
        divs    d3,d2                   *256*delta x / delta y
        muls    d1,d2                   *y1*256*delta x / delta y
        lsr.l   #8,d2                   *y1*delta x / delta y
        sub.w   d2,d0                   *x0-y1*delta x / delta y
        move.w  d6,d1                   *y1=ymin
        movem.l (a7)+,d2-d3
c3      cmp.w   d7,d1                   *y1>ymax
        bmi     c4                      *nein
        cmp.w   d7,d3                   *y2>ymax
        bpl     eline                   *ja
        movem.l d2-d3,-(a7)
        sub.w   d0,d2                   *delta x
        sub.w   d1,d3                   *delta y
        ext.l   d2
        lsl.l   #8,d2                   *256*delta x
        sub.w   d7,d1                   *ymax-y1
        neg.w   d1
        divs    d3,d2                   *256*delta x / delta y
        muls    d1,d2                   *(200-y1)*256*delta x / delta y
        lsr.l   #8,d2                   *(200-y1)*delta x / delta y
        add.w   d2,d0                   *x0+(200-y1)*delta x / delta y
        move.w  d7,d1                   *y1=ymax
        movem.l (a7)+,d2-d3
c4      cmp.w   d6,d3
        bpl     c5
        movem.l d0-d1,-(a7)     
        neg.w   d0
        neg.w   d1
        add.w   d2,d0                   *delta x
        add.w   d3,d1                   *delta y
        ext.l   d0
        sub.w   d6,d3                   *y2-ymin
        lsl.l   #8,d0                   *256*delta x
        divs    d1,d0                   *256*delta x / delta y
        muls    d3,d0                   *y2*256*delta x / delta y
        lsr.l   #8,d0                   *y2*delta x / delta y
        sub.w   d0,d2                   *x2-y2*delta x / delta y
        move.w  d6,d3                   *y2=ymin
        movem.l (a7)+,d0-d1
c5      cmp.w   d7,d3                   *y2>ymax
        bmi     c6                      *nein
        movem.l d0-d1,-(a7)
        neg.w   d0
        neg.w   d1
        add.w   d2,d0                   *delta x
        add.w   d3,d1                   *delta y
        ext.l   d0
        lsl.l   #8,d0                   *256*delta x
        sub.w   d7,d3                   *y2-ymax
        neg.w   d3
        divs    d1,d0                   *256*delta x / delta y
        muls    d3,d0                   *(200-y2)*256*delta x / delta y
        lsr.l   #8,d0                   *(200-y2)*delta x / delta y
        add.w   d0,d2                   *x2+(200-y2)*delta x / delta y
        move.w  d7,d3                   *y1=ymax
        movem.l (a7)+,d0-d1

*extrem schnelle line-routine bitte beachten
*falls schnellere bekannt bitte melden
*d0 = x-koordinate punkt 1
*d1 = y-koordinate punkt 1
*d2 = x-koordinate punkt 2
*d3 = y-koordiante punkt 2
c6      move.w      colour(a4),d6
          move.l  screen(a4),a0   *start bildspeicher
        sub.w   d0,d2           *delta x
        move.w  d0,d5           *x nach d5
          and.w     #7,d5               *fuer farbmaske
        lsr.w   #3,d0           *8 bitspalten pro wortspalte
        lsl.w   #1,d0           *nur gerade adressen
        add.w   d0,a0           *startadresse der spalte
        move.w  xres(a4),d4
        lsr.w   #2,d4           *negative steigung
        neg.w   d4
        sub.w   d1,d3           *delta y
        beq     hl1             *delta y = 0 horizontale linie
        bpl.s   mst2            *positive steigung
        neg.w   d3              *delta y = -delta y
        bra.s   mst2a
mst2    neg.w   d4              *positive steigung
mst2a   move.w  #$8080,d0       *bitmaske fuer farbe weiss
        ror.w   d5,d0           *bitmaske fuer linienanfang
        mulu    xres(a4),d1     *startzeile * zeilenlaenge
        lsr.l   #2,d1
        add.w   d1,a0           *startadresse fuer zeile
        tst.w   d2              *delta x = 0 ?
        beq     vl1             *ja vertikale linie
        cmp.w   d2,d3           * x- oder y-richtung
        beq.s   dline           *diagonale
        bgt     yl              *y-richtung
*x-richtung
        move.w  d2,d7
        neg.w   d7              *flag vorbereiten
        move.w  d2,d5
        subq.w  #1,d5           *punktzaehler
          bmi       eline
        move.w  d0,d1           *bitmaske
        bra.s   lab12
lab11   add.w   d3,d7           *flag testen
        bpl.s   lab14
        or.w    d0,d1           *punktmaske
lab12   ror.w   #1,d0           *naechste spalte
        bcs.s   lab13           *naechste wortspalte
        dbra    d5,lab11
          not.w     d1
          and.w     d1,(a0)
          not.w     d1
          and.w     d6,d1
        or.w    d1,(a0)         *punkte setzen
        movem.l (a7)+,d0-d1/a0
        rts
lab13   not.w       d1
          and.w     d1,(a0)
          not.w     d1
          and.w     d6,d1
          or.w    d1,(a0)+        *punkte setzen
        moveq   #0,d1
        dbra    d5,lab11
        movem.l (a7)+,d0-d1/a0
        rts
lab14   not.w       d1
          and.w     d1,(a0)
          not.w     d1
          and.w     d6,d1
          or.w    d1,(a0)         *punkte setzen
        move.w  d0,d1           *bitmaske
        add.w   d4,a0           *naechste zeile
        sub.w   d2,d7           *flag
        bra.s   lab12
*diagonale
dline   move.w      d0,d1
          not.w     d1
          and.w     d1,(a0)
          not.w     d1
          and.w     d6,d1
          or.w    d1,(a0)         *punkt setzen
        add.w   d4,a0           *naechste zeile
        ror.w   #1,d0           *naechste punktspalte
        bcs.s   lab21           *naechste wortspalte
        dbra    d2,dline
        movem.l (a7)+,d0-d1/a0
        rts
lab21   addq.w  #2,a0           *naechste wortspalte
        dbra    d2,dline
        movem.l (a7)+,d0-d1/a0
        rts  
*y-richtung
yl      move.w  d3,d7           *flag vorbereiten
        move.w  d3,d5
        subq.w  #1,d5           *punktzaehler
          bmi       eline
        bra.s   lab32
lab31   sub.w   d2,d7           *flag testen
        bmi.s   lab33
lab32   move.w      d0,d1
          not.w     d1
          and.w     d1,(a0)
          not.w     d1
          and.w     d6,d1
          or.w    d1,(a0)         *punkt setzen
        add.w   d4,a0           *naechste zeile
        dbra    d5,lab31
        movem.l (a7)+,d0-d1/a0
        rts
lab33   add.w   d3,d7           *flag
        ror.w   #1,d0           *naechste bitspalte
        bcc.s   lab32
        addq.w  #2,a0           *naechste wortspalte
        bra.s   lab32

*routine for horizontal lines
hl1     move.w  #$8080,d0       *bitmask
        ror.w   d5,d0           *bitmask fuer spalte
        mulu    xres(a4),d1
        lsr.l   #2,d1           *startzeile * zeilenlaenge
        add.w   d1,a0           *startadresse fuer zeile
        cmp.b   #-128,d0        *wortgrenze
        beq.s   hl2             *special
        moveq   #0,d1           *bitmaske loeschen
hl1l    or.w    d0,d1           *bitmaske aktualisieren
hl1l1   ror.w   #1,d0           *bitmaske fuer spalte
        bcs.s   lab41           *noch gleiche wortspalte
        dbra    d2,hl1l         *naechster punkt
          not.w     d1
          and.w     d1,(a0)
          not.w     d1
          and.w     d6,d1
        or.w    d1,(a0)         *punkte setzen
        movem.l (a7)+,d0-d1/a0
        rts
lab41   not.w       d1
          and.w     d1,(a0)
          not.w     d1
          and.w     d6,d1
          or.w    d1,(a0)+        *punkte setzen
hl2     subq.w  #8,d2           *keine wortgrenze mehr
        bmi.s   lab52
        move.w  d6,(a0)+        *punkte
        bra.s   hl2
lab52   cmp.w   #-8,d2          *wortgrenze
        beq         eline
        addq.w  #7,d2           *letzten reset
          move.w    #$8080,d0
          move.w    d0,d1
          bra.s     elab53
lab53   ror.w       #1,d0
          or.w      d0,d1
elab53    dbra      d2,lab53
          not.w     d1
          and.w     d1,(a0)
          not.w     d1
          and.w     d6,d1
          or.w      d1,(a0)
        movem.l (a7)+,d0-d1/a0
        rts
        
*routine for vertical lines
vl1     move.w      d0,d1
        and.w     d6,d1
        not.w     d0
vl1l    and.w     d0,(a0)
        or.w    d1,(a0)         *Set pixel
        add.w   d4,a0           *Next line
        dbra    d3,vl1l         *Next pixel
eline   movem.l (a7)+,d0-d1/a0
        rts

farbe   DC.W    $0000,$0000,$00FF,$00FF,$FF00,$FF00,$FFFF,$FFFF

*QL Font table translated into IBM form
tabelle
  dc.b    0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
  dc.b    16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31
  dc.b    32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47
  dc.b    48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63
  dc.b    64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79
  dc.b    80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95
  dc.b    96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111
  dc.b    112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127
  dc.b    132,134,134,130,148,149,237,129,128,164,158,145,160,133,131,137
  dc.b    138,136,139,161,141,140,162,149,147,163,151,150,225,155,157,139
  dc.b    142,143,143,144,153,162,237,154,135,165,146,146,224,235,233,32
  dc.b    230,227,32,161,168,32,36,32,174,175,248,246,60,62,94,32
  dc.b    32,32,32,32,32,110,32,226,5,3,4,6,94,32,236,234
  dc.b    239,32,32,228,48,89,197,197,240,241,135,240,243,240,242,247
  dc.b    254,219,219,145,32,238,32,121,32,32,32,32,172,171,32,32
  dc.b    32,32,32,229,231,32,251,32,32,32,32,32,179,32,32,32

sin      DC.W    $0000,$4000,$011D,$3FFD,$023B,$3FF6,$0359,$3FE9
         DC.W    $0476,$3FD8,$0593,$3FC1,$06B0,$3FA6,$07CC,$3F85
         DC.W    $08E8,$3F60,$0A03,$3F36,$0B1D,$3F07,$0C36,$3ED2
         DC.W    $0D4E,$3E99,$0E65,$3E5C,$0F7B,$3E19,$1090,$3DD1
         DC.W    $11A4,$3D85,$12B6,$3D34,$13C6,$3CDE,$14D6,$3C83
         DC.W    $15E3,$3C23,$16EF,$3BBF,$17F9,$3B56,$1901,$3AE9
         DC.W    $1A07,$3A77,$1B0C,$3A00,$1C0E,$3985,$1D0E,$3906
         DC.W    $1E0B,$3882,$1F07,$37F9,$2000,$376C,$20F6,$36DB
         DC.W    $21EA,$3646,$22DB,$35AC,$23C9,$350E,$24B5,$346C
         DC.W    $259E,$33C6,$2684,$331C,$2766,$326E,$2846,$31BC
         DC.W    $2923,$3106,$29FC,$304D,$2AD3,$2F8F,$2BA5,$2ECE
         DC.W    $2C75,$2E09,$2D41,$2D41,$2E09,$2C75,$2ECE,$2BA5
         DC.W    $2F8F,$2AD3,$304D,$29FC,$3106,$2923,$31BC,$2846
         DC.W    $326E,$2766,$331C,$2684,$33C6,$259E,$346C,$24B5
         DC.W    $350E,$23C9,$35AC,$22DB,$3646,$21EA,$36DB,$20F6
         DC.W    $376C,$2000,$37F9,$1F07,$3882,$1E0B,$3906,$1D0E
         DC.W    $3985,$1C0E,$3A00,$1B0C,$3A77,$1A07,$3AE9,$1901
         DC.W    $3B56,$17F9,$3BBF,$16EF,$3C23,$15E3,$3C83,$14D6
         DC.W    $3CDE,$13C6,$3D34,$12B6,$3D85,$11A4,$3DD1,$1090
         DC.W    $3E19,$0F7B,$3E5C,$0E65,$3E99,$0D4E,$3ED2,$0C36
         DC.W    $3F07,$0B1D,$3F36,$0A03,$3F60,$08E8,$3F85,$07CC
         DC.W    $3FA6,$06B0,$3FC1,$0593,$3FD8,$0476,$3FE9,$0359
         DC.W    $3FF6,$023B,$3FFD,$011D,$4000,$0000,$3FFD,$FEE2
         DC.W    $3FF6,$FDC4,$3FE9,$FCA6,$3FD8,$FB89,$3FC1,$FA6C
         DC.W    $3FA6,$F94F,$3F85,$F833,$3F60,$F717,$3F36,$F5FC
         DC.W    $3F07,$F4E2,$3ED2,$F3C9,$3E99,$F2B1,$3E5C,$F19A
         DC.W    $3E19,$F084,$3DD1,$EF6F,$3D85,$EE5B,$3D34,$ED49
         DC.W    $3CDE,$EC39,$3C83,$EB29,$3C23,$EA1C,$3BBF,$E910
         DC.W    $3B56,$E806,$3AE9,$E6FE,$3A77,$E5F8,$3A00,$E4F3
         DC.W    $3985,$E3F1,$3906,$E2F1,$3882,$E1F4,$37F9,$E0F8
         DC.W    $376C,$E000,$36DB,$DF09,$3646,$DE15,$35AC,$DD24
         DC.W    $350E,$DC36,$346C,$DB4A,$33C6,$DA61,$331C,$D97B
         DC.W    $326E,$D899,$31BC,$D7B9,$3106,$D6DC,$304D,$D603
         DC.W    $2F8F,$D52C,$2ECE,$D45A,$2E09,$D38A,$2D41,$D2BE
         DC.W    $2C75,$D1F6,$2BA5,$D131,$2AD3,$D070,$29FC,$CFB2
         DC.W    $2923,$CEF9,$2846,$CE43,$2766,$CD91,$2684,$CCE3
         DC.W    $259E,$CC39,$24B5,$CB93,$23C9,$CAF1,$22DB,$CA53
         DC.W    $21EA,$C9B9,$20F6,$C924,$2000,$C893,$1F07,$C806
         DC.W    $1E0B,$C77D,$1D0E,$C6F9,$1C0E,$C67A,$1B0C,$C5FF
         DC.W    $1A07,$C588,$1901,$C516,$17F9,$C4A9,$16EF,$C440
         DC.W    $15E3,$C3DC,$14D6,$C37C,$13C6,$C321,$12B6,$C2CB
         DC.W    $11A4,$C27A,$1090,$C22E,$0F7B,$C1E6,$0E65,$C1A3
         DC.W    $0D4E,$C166,$0C36,$C12D,$0B1D,$C0F8,$0A03,$C0C9
         DC.W    $08E8,$C09F,$07CC,$C07A,$06B0,$C059,$0593,$C03E
         DC.W    $0476,$C027,$0359,$C016,$023B,$C009,$011D,$C002
         DC.W    $0000,$C000,$FEE2,$C002,$FDC4,$C009,$FCA6,$C016
         DC.W    $FB89,$C027,$FA6C,$C03E,$F94F,$C059,$F833,$C07A
         DC.W    $F717,$C09F,$F5FC,$C0C9,$F4E2,$C0F8,$F3C9,$C12D
         DC.W    $F2B1,$C166,$F19A,$C1A3,$F084,$C1E6,$EF6F,$C22E
         DC.W    $EE5B,$C27A,$ED49,$C2CB,$EC39,$C321,$EB29,$C37C
         DC.W    $EA1C,$C3DC,$E910,$C440,$E806,$C4A9,$E6FE,$C516
         DC.W    $E5F8,$C588,$E4F3,$C5FF,$E3F1,$C67A,$E2F1,$C6F9
         DC.W    $E1F4,$C77D,$E0F8,$C806,$E000,$C893,$DF09,$C924
         DC.W    $DE15,$C9B9,$DD24,$CA53,$DC36,$CAF1,$DB4A,$CB93
         DC.W    $DA61,$CC39,$D97B,$CCE3,$D899,$CD91,$D7B9,$CE43
         DC.W    $D6DC,$CEF9,$D603,$CFB2,$D52C,$D070,$D45A,$D131
         DC.W    $D38A,$D1F6,$D2BE,$D2BE,$D1F6,$D38A,$D131,$D45A
         DC.W    $D070,$D52C,$CFB2,$D603,$CEF9,$D6DC,$CE43,$D7B9
         DC.W    $CD91,$D899,$CCE3,$D97B,$CC39,$DA61,$CB93,$DB4A
         DC.W    $CAF1,$DC36,$CA53,$DD24,$C9B9,$DE15,$C924,$DF09
         DC.W    $C893,$DFFF,$C806,$E0F8,$C77D,$E1F4,$C6F9,$E2F1
         DC.W    $C67A,$E3F1,$C5FF,$E4F3,$C588,$E5F8,$C516,$E6FE
         DC.W    $C4A9,$E806,$C440,$E910,$C3DC,$EA1C,$C37C,$EB29
         DC.W    $C321,$EC39,$C2CB,$ED49,$C27A,$EE5B,$C22E,$EF6F
         DC.W    $C1E6,$F084,$C1A3,$F19A,$C166,$F2B1,$C12D,$F3C9
         DC.W    $C0F8,$F4E2,$C0C9,$F5FC,$C09F,$F717,$C07A,$F833
         DC.W    $C059,$F94F,$C03E,$FA6C,$C027,$FB89,$C016,$FCA6
         DC.W    $C009,$FDC4,$C002,$FEE2,$C000,$FFFF,$C002,$011D
         DC.W    $C009,$023B,$C016,$0359,$C027,$0476,$C03E,$0593
         DC.W    $C059,$06B0,$C07A,$07CC,$C09F,$08E8,$C0C9,$0A03
         DC.W    $C0F8,$0B1D,$C12D,$0C36,$C166,$0D4E,$C1A3,$0E65
         DC.W    $C1E6,$0F7B,$C22E,$1090,$C27A,$11A4,$C2CB,$12B6
         DC.W    $C321,$13C6,$C37C,$14D6,$C3DC,$15E3,$C440,$16EF
         DC.W    $C4A9,$17F9,$C516,$1901,$C588,$1A07,$C5FF,$1B0C
         DC.W    $C67A,$1C0E,$C6F9,$1D0E,$C77D,$1E0B,$C806,$1F07
         DC.W    $C893,$1FFF,$C924,$20F6,$C9B9,$21EA,$CA53,$22DB
         DC.W    $CAF1,$23C9,$CB93,$24B5,$CC39,$259E,$CCE3,$2684
         DC.W    $CD91,$2766,$CE43,$2846,$CEF9,$2923,$CFB2,$29FC
         DC.W    $D070,$2AD3,$D131,$2BA5,$D1F6,$2C75,$D2BE,$2D41
         DC.W    $D38A,$2E09,$D45A,$2ECE,$D52C,$2F8F,$D603,$304D
         DC.W    $D6DC,$3106,$D7B9,$31BC,$D899,$326E,$D97B,$331C
         DC.W    $DA61,$33C6,$DB4A,$346C,$DC36,$350E,$DD24,$35AC
         DC.W    $DE15,$3646,$DF09,$36DB,$DFFF,$376C,$E0F8,$37F9
         DC.W    $E1F4,$3882,$E2F1,$3906,$E3F1,$3985,$E4F3,$3A00
         DC.W    $E5F8,$3A77,$E6FE,$3AE9,$E806,$3B56,$E910,$3BBF
         DC.W    $EA1C,$3C23,$EB29,$3C83,$EC39,$3CDE,$ED49,$3D34
         DC.W    $EE5B,$3D85,$EF6F,$3DD1,$F084,$3E19,$F19A,$3E5C
         DC.W    $F2B1,$3E99,$F3C9,$3ED2,$F4E2,$3F07,$F5FC,$3F36
         DC.W    $F717,$3F60,$F833,$3F85,$F94F,$3FA6,$FA6C,$3FC1
         DC.W    $FB89,$3FD8,$FCA6,$3FE9,$FDC4,$3FF6,$FEE2,$3FFD
