;                   FACT : fonction SUPERBASIC renvoyant la factorielle
;                          d'un entier

;                   utilisation : factorielle = FACT(nombre)


bv_rip              equ       $58
ri_float            equ       $08
ri_mult             equ       $0e


                    move.w    bp_init,a0
                    lea       TABLE,a1
                    jsr       (a0)
                    rts

FACT                move.w    ca_gtint,a0
                    jsr       (a0)
                    bne.s     ERREUR_BP
                    sub.w     #1,d3               La fonction n'accepte
                    bne.s     ERREUR_BP           qu'un paramtre

                    move.w    0(a6,a1.l),d7       Celui-ci doit tre
                    bmi.s     ERREUR_BP           compris entre 0...
                    bne.s     POSITIF
                    moveq     #1,d7               ( 0! = 1! )
                    move.w    d7,0(a6,a1.l)
POSITIF             cmp.w     #300,d7             ...et 300 inclus
                    bhi.s     ERREUR_OV

                    moveq     #10,d1              Rserve 10 octets sur la
                    move.w    bv_chrix,a0         pile arithmtique
                    jsr       (a0)
                    move.l    bv_rip(a6),a1

                    move.w    ri_exec,a0          Opration arithmtique

                    moveq     #ri_float,d0        Code l'entier en
                    jsr       (a0)                flottant

NOMBRE_SUIVANT      sub.w     #1,d7
                    beq.s     SORTIE
                    sub.l     #2,a1
                    move.w    d7,0(a6,a1.l)

                    moveq     #ri_float,d0
                    jsr       (a0)

                    moveq     #ri_mult,d0
                    jsr       (a0)

                    bra.s     NOMBRE_SUIVANT

SORTIE              move.l    a1,bv_rip(a6)       Rservation pour retour
                    moveq     #2,d4               Type = flottant
                    rts
ERREUR_BP           moveq     #err_bp,d0
                    rts
ERREUR_OV           moveq     #err_ov,d0
                    rts

TABLE               dc.w      0,0,1
                    dc.w      FACT-*
                    dc.b      4,"FACT"
                    dc.w      0

                    END
