;                   FRACT : fonction SUPERBASIC renvoyant la partie
;                           fractionnaire d'un nombre  virgule flottante

;                   utilisation : partie_fractionnaire = FRACT(nombre)


ri_neg              equ       $14


                    move.w    bp_init,a0
                    lea       TABLE,a1
                    jsr       (a0)
                    rts

FRACT               move.w    ca_gtfp,a0
                    jsr       (a0)
                    bne.s     ERREUR_BP
                    sub.w     #1,d3               La fonction n'accepte
                    bne.s     ERREUR_BP           qu'un paramtre

                    move.b    2(a6,a1.l),d7       Teste et sauve le signe
                    bpl.s     POSITIF_OU_NUL

                    move.w    ri_exec,a0          Opration arithmtique

                    moveq     #ri_neg,d0          Inverse le signe
                    jsr       (a0)

POSITIF_OU_NUL      move.w    0(a6,a1.l),d1       d1 = exposant
                    move.l    2(a6,a1.l),d2       d2 = mantisse
                    move.w    d1,d3
                    sub.w     #$800,d3
                    ble.s     TEST_INVERSION      Pas de partie entire

                    cmp.w     #32,d3
                    ble.s     DANS_LA_LIMITE
                    moveq     #32,d3              32 dcalages maximum

DANS_LA_LIMITE      sub.w     d3,d1               Calcul de l'exposant
                    lsl.l     d3,d2               Calcul de la mantisse
                    bclr      #31,d2              Nombre positif ou nul

                    move.w    d1,0(a6,a1.l)       Place l'exposant
                    move.l    d2,2(a6,a1.l)       Place la mantisse

TEST_INVERSION      tst.b     d7
                    bpl.s     SORTIE

                    moveq     #ri_neg,d0          Inverse le signe
                    jsr       (a0)

SORTIE              moveq     #2,d4               Type = flottant
                    rts
ERREUR_BP           moveq     #err_bp,d0
                    rts

TABLE               dc.w      0,0,1
                    dc.w      FRACT-*
                    dc.b      5,"FRACT"
                    dc.w      0

                    END
