*         SuperBASIC-Function GET_STUFF$, keine Parameter.
*         Gibt Inhalt des Hotkey-Stuffers zurck.
*         Vorher wird FILES-Thing aus QPAC2 gestartet, wenn vorhanden.
*          3/91, H.Gieleen
*
          section prog
*
          include   flp1_qdos_keys
          include   flp1_error_keys
          include   flp1_hk_vector
          include   flp1_Thing_keys
*
          xref      find_TH,use_th,free_th
*
bv.rip    equ       $58
*
          move.w    bp.init,a2
          lea       procs,a1
          jsr       (a2)
          rts
*
procs     dc.w      0,0,1
          dc.w      gstuff-*
          dc.b      10,'GET_STUFF$'
          dc.w      0
*
gstuff    moveq     #err.bp,d0
          moveq     #0,d7
          cmp.l     a3,a5
          bne       exit                ;keine Parameter erlaubt
no_pars   bsr       find_TH             ;Adresse THING-thing nach A3
          bne       exit                ;Thingsystem nicht gefunden
          move.l    th_exec(a3),a3
          moveq     #myself,d1
          move.l    #$00080000,d2       ;priority/timeout
          lea       fi_name,a0
          jsr       (a3)                ;Files-thing starten
          move.l    d1,d6               ;Job-id merken
          tst.l     d0
          bne.s     get_stuff           ;Fehler  Stuffer direkt lesen
wait      moveq     #mt.susjb,d0        ;Basic 0,2 sec. suspendieren, Zeit sparen
          moveq     #myself,d1
          moveq     #10,d3
          trap      #1
          moveq     #mt.jinf,d0         ;Prioritt erfragen
          move.l    d6,d1
          moveq     #0,d2
          trap      #1
          cmp.b     #1,d3               ;Prioritt=1? dann ist Job im Button Frame
          bne.s     wait
          moveq     #mt.frjob,d0        ;und dann werfen wir ihn raus
          move.l    d6,d1
          moveq     #0,d3
          trap      #1
get_stuff lea       hotkey$,a0
          bsr       use_th
          move.l    a1,a3               ;Adresse des Hotkey Linkage Block
          lea       hotkey$,a0
          bsr       free_th
          move.l    hk.gtbuf(a3),a2
          moveq     #0,d0               ;letzter Stuffer
          jsr       (a2)                ;d2=Lnge Stuffer String, a1=Adresse
          move.l    a1,a5
          cmp.w     #0,d2
          beq.s     exit
          move.w    bv.chrix,a2
          move.w    d2,d6
          move.w    d2,d1
          addq.w    #3,d1
          bclr      #0,d1               ;Stringlnge auf geraden Wert aufrunden
          ext.l     d1
          move.w    d1,d7
          jsr       (a2)                ;Platz auf'm Stack schaffen
          move.l    bv.rip(a6),a1
          sub.w     d7,a1
          move.w    d6,0(a6,a1.l)       ;Lnge speichern
          move.l    a1,a4
          addq.l    #2,a4
          subq.w    #1,d6
r_loop    move.b    (a5)+,0(a6,a4.l)
          addq.l    #1,a4
          dbra      d6,r_loop           ;Stufferstring auf Stack kopieren
          move.l    a1,bv.rip(a6)       ;Stackpointer updaten
          moveq     #1,d4               ;String zurckgeben
          moveq     #0,d0
exit      rts
*
hotkey$   dc.w      6,'HOTKEY'
fi_name   dc.w      5,'FILES'
*
          end
