;                       SGN% :   fonction SUPERBASIC renvoyant le signe
;                                d'un nombre  virgule flottante

;                                -1 : nombre ngatif
;                                 0 : zro
;                                 1 : nombre positif

;                utilisation :   signe% = SGN%(nombre)


bv_rip              equ       $58


                    move.w    bp_init,a0
                    lea       TABLE,a1
                    jsr       (a0)
                    rts

SGN                 move.w    ca_gtfp,a0
                    jsr       (a0)
                    bne.s     ERREUR_BP
                    sub.w     #1,d3               La fonction n'accepte
                    bne.s     ERREUR_BP           qu'un paramtre

                    move.l    2(a6,a1.l),d1
                    beq.s     ZERO                Cas particulier : zro

                    swap      d1                  Autrement, calcule le
                    ext.l     d1                  rsultat
                    swap      d1
                    bset      d0,d1

PLACE_RESULTAT      move.w    d1,4(a6,a1.l)       Place le rsultat
ZERO                add.l     #4,a1               a1 pointe le rsultat
                    move.l    a1,bv_rip(a6)       Rservation pour retour
                    moveq     #3,d4               Type = entier
                    rts
ERREUR_BP           moveq     #err_bp,d0
                    rts

TABLE               dc.w      0,0,1
                    dc.w      SGN-*
                    dc.b      4,"SGN%"
                    dc.w      0

                    END
