;                      TRIM$ :   fonction SUPERBASIC renvoyant une chane
;                                de caractres sans espaces  ses
;                                extrmits

;                utilisation :   chane_ss_esp$ = TRIM$(chane_ac_esp$)


bv_rip              equ       $58


                    move.w    bp_init,a0
                    lea       TABLE,a1
                    jsr       (a0)
                    rts

TRIM                move.w    ca_gtstr,a0
                    jsr       (a0)
                    bne.s     ERREUR_BP
                    sub.w     #1,d3               La fonction n'accepte
                    bne.s     ERREUR_BP           qu'un paramtre

                    move.w    0(a6,a1.l),d2       d2 = longueur chane
                    ext.l     d2

                    move.l    d2,d0               Teste la non-parit
                    and.w     #1,d0               de d2

                    move.l    a1,a2
                    add.l     #1,a2               a2 pointe av. pre. car.
                    move.l    a2,a3
                    add.l     d2,a3
                    add.l     #1,a3               a3 pointe ap. der. car.
                    moveq     #32,d3              Code du caractre " "

                    moveq     #-1,d4
COMPT_AVANT         add.w     #1,d4
                    cmp.w     d2,d4               Sortie si chane vide
                    beq.s     SORTIE              ou compose d'espaces
                    add.l     #1,a2
                    cmp.b     0(a6,a2.l),d3
                    beq.s     COMPT_AVANT
                    ext.l     d4                  d4 = Nb d'espaces dev.

                    moveq     #-1,d5
COMPT_ARRIERE       add.w     #1,d5
                    sub.l     #1,a3
                    cmp.b     0(a6,a3.l),d3
                    beq.s     COMPT_ARRIERE
                    ext.l     d5                  d5 = Nb d'espaces der.

                    move.w    d2,d6               Calcule la longueur
                    sub.w     d4,d6               de la chane retourne
                    sub.w     d5,d6               par la fonction
                    move.w    d6,d7
                    ext.l     d7

                    move.l    d7,d1               Teste la non-parit
                    and.w     #1,d1               de d7

                    sub.w     #1,d6               Initialisation compteur

                    move.l    a1,a2
                    add.l     #1,a2
                    moveq     #-1,d3
                    bra.s     DIFFERENTS_CAS

SORTIE              sub.l     #1,a2
                    add.l     d0,a2
                    moveq     #0,d7               Longueur nulle

PLACE_LONGUEUR      move.w    d7,0(a6,a2.l)       Place la longueur
                    move.l    a2,bv_rip(a6)       Rservation pour retour
                    moveq     #1,d4               Type = chane
                    moveq     #0,d0               Pas d'erreur
                    rts
ERREUR_BP           moveq     #err_bp,d0
                    rts

DIFFERENTS_CAS      tst.b     d0
                    bne.s     AUTRES_CAS
                    tst.b     d1
                    beq.s     AUTRES_CAS

                    tst.w     d5
                    beq.s     AUCUN_ESPACE

                    add.l     d2,a2
                    sf        0(a6,a2.l)          Octet nul pour parit
                    move.l    a2,a3
                    sub.l     #1,a2
SUITE               sub.l     d5,a3
                    bsr.s     DEPLACE_CHAINE
                    sub.l     #1,a2
                    bra.s     PLACE_LONGUEUR

AUCUN_ESPACE        add.l     d4,a2
                    move.l    a2,a3
                    add.l     #1,a3
                    moveq     #1,d3
                    bsr.s     DEPLACE_CHAINE
                    sf        0(a6,a2.l)          Octet nul pour parit
                    sub.l     d7,a2
                    sub.l     #2,a2
                    bra.s     PLACE_LONGUEUR

AUTRES_CAS          not.b     d1
                    and.b     d0,d1
                    add.l     d2,a2
                    move.l    a2,a3
                    add.l     d1,a2
                    bra.s     SUITE

DEPLACE_CHAINE      move.b    0(a6,a3.l),0(a6,a2.l)         Dplace les
                    add.l     d3,a3                         caractres
                    add.l     d3,a2
                    dbf       d6,DEPLACE_CHAINE
                    rts

TABLE               dc.w      0,0,1
                    dc.w      TRIM-*
                    dc.b      5,"TRIM$"
                    dc.w      0

                    END
